/*
 * JobSchedulerManagedCustomJob.java
 * Created on 25.10.2005
 * 
 */
package sos.scheduler.managed;

import java.io.File;
import java.io.FileOutputStream;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import sos.connection.SOSConnection;
import sos.hostware.Factory_processor;

/**
 * 
 *
 * @author Andreas Liebert 
 */
public class JobSchedulerManagedCustomReportJob extends
		JobSchedulerManagedDatabaseJob {
	
	private ManagedReporter reporter;
	
	private Factory_processor processor;
	
	// gab es wenigstens ein Ergebnis?
	private boolean hasResult;
	
	public boolean spooler_init() {
		boolean rc =  super.spooler_init();		
		try{
			reporter = new ManagedReporter(this);
		
		} catch(Exception e){
			try{getLogger().warn("Failed to initialize Job: "+e);}catch(Exception ex){}
			rc=false;
		}
		return rc;
	}

	/* (non-Javadoc)
	 * @see sos.scheduler.managed.JobSchedulerManagedDatabaseJob#executeStatements(sos.connection.SOSConnection, java.lang.String)
	 */
	protected void executeStatements(SOSConnection conn, String command)
			throws Exception {
		hasResult=false;
		reporter.setBody("Report for statement:\n[sql]");
				
		reporter.setSubject("Database Report [taskid]");
		reporter.addReplacement("\\[sql\\]",command);
		
		String language = "";
		File template;
		if(getOrderPayload()!=null && getOrderPayload().var("scheduler_order_report_template")!=null &&
				getOrderPayload().var("scheduler_order_report_template").length()>0){
			debugParamter(getOrderPayload(),"scheduler_order_report_template");
			template = new File(getOrderPayload().var("scheduler_order_report_template"));
			if (!template.canRead()){
				throw new Exception("Could not read template: "+template.getAbsolutePath());				
		    }
		} else throw new Exception("No template was set.");
		if(getOrderPayload()!=null && getOrderPayload().var("scheduler_order_report_language")!=null &&
				getOrderPayload().var("scheduler_order_report_language").length()>0){
			debugParamter(getOrderPayload(),"scheduler_order_report_language");
			language = getOrderPayload().var("scheduler_order_report_language");			
		} 
		// command aufteilen in Blcke, deren Ergebnisse behalten werden
		//String[] blocks = command.split("/\\*\\s*result2array\\(\\s*\"");
		String[] blocks = command.split("/\\*\\s*(variable|VARIABLE)\\s*");
		//String[] blocks = command.split("/\\*\\s*variable\\s*");
		Vector variables = new Vector();
		String forerunscript = "";
		
		if(blocks.length<=1){
			//getLogger().info("No result2array commands found.");
			getLogger().info("No variable commands found.");
			super.executeStatements(conn, command);
			HashMap results = conn.get();
			if (results!=null && !results.isEmpty()) reporter.setHasResult(true);
			forerunscript = result2variables(results);
		}
		else{
			// durch die Blcke iterieren
			// ausfhren, dann in Variable schreiben
			int counter = 0;
			while (counter<blocks.length){
				super.executeStatements(conn, blocks[counter]);
				counter++;
				if (counter<blocks.length){
					String paramName = blocks[counter].substring(0,blocks[counter].indexOf("*/")).trim();
					// getLogger().debug3("result2array(\""+paramName+"\")");
					getLogger().debug3("variable "+paramName+"");
					//HashMap results = conn.get();
					forerunscript += result2array(paramName, conn);
					forerunscript += "\n";
					blocks[counter] = blocks[counter].substring(blocks[counter].indexOf("*/")+2);
					if(blocks[counter].trim().length()<1) counter++;
				}
			}
		}
		
		getLogger().debug3("start script:\n"+ forerunscript);
		FileOutputStream fos = new FileOutputStream("forerun.js");
		fos.write(forerunscript.getBytes());
		fos.flush();
		fos.close();
		processor = new Factory_processor();
		try{
		File reportFile = reporter.getReportFile();
		processor.set_document_filename(reportFile.getAbsolutePath());
		processor.set_language("javascript");
		processor.set_template_filename( template.getAbsolutePath() );
		processor.add_parameters();
		if (getLogger() != null) { getLogger().debug9(".... trying to parse start script"); }
		
		processor.parse(forerunscript);
		getLogger().info("Processing report...");
		processor.process();
		processor.close_output_file();
		//getLogger().debug6("Output dir: "+processor.document_dir());
		//getLogger().debug6("Output File: "+processor.document_filename());
		//getLogger().debug6("File exists: "+new File(processor.document_filename()).exists());
		getLogger().debug3("Closing factory_processor...");
		reporter.setHasResult(hasResult);
		reporter.report();
		
		} catch (Exception e){
			throw new Exception("Error occured processing report: "+e,e);
		} finally {
			processor.close();
		}
	}
	
	private String result2array(String paramName, SOSConnection conn) throws Exception{
		String forerunscript = "var "+paramName+" = new Array();\n";
		HashMap results = conn.get();
		int counter=0;
		while(results!=null && !results.isEmpty()){
			hasResult = true;
			forerunscript += paramName +"["+counter+"] = new Object();\n";
			
			Iterator keysIt = results.keySet().iterator();
			while(keysIt.hasNext()){
				String key = keysIt.next().toString();
				String value = results.get(key).toString();
				
				value = value.replaceAll("\\\\","\\\\\\\\");
				value = value.replaceAll("\"","\\\\\"");
				value = value.replaceAll("\r\n","\n");
				value = value.replaceAll("\\n","\\\\n\" ;\n"+ paramName +"["+counter+"] [\""+key+"\"] += \"");
				
				forerunscript += paramName +"["+counter+"] [\""+key+"\"] = \""+value+"\";\n";
			}
			counter++;
			results=conn.get();
		}
		
		return forerunscript;
	}
	
	private String result2variables(HashMap results) throws Exception{
		String forerunscript = "";
		Iterator keysIt = results.keySet().iterator();
		while(keysIt.hasNext()){
			String key = keysIt.next().toString();
			String value = results.get(key).toString();
			
			value = value.replaceAll("\\\\","\\\\\\\\");
			value = value.replaceAll("\"","\\\\\"");
			value = value.replaceAll("\r\n","\n");
			value = value.replaceAll("\\n","\\\\n\" ;\n"+ key +" += \"");
			
			forerunscript += key +" = \""+value+"\";\n";
		}
		return forerunscript;
	}
}
