package sos.util;


import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.File;
import java.util.zip.GZIPOutputStream;

/**
 * <p>Title: </p>
 * <p>Description: Java GZip client</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: SOS GmbH</p>
 * @author <a href="mailto:ghassan.beydoun@sos-berlin.com">Ghassan Beydoun</a>
 * @version $Id: SOSGZip.java 799 2005-03-29 10:20:02Z ap $
 */


public class SOSGZip {

  /**
   * @param inputFile
   * @param outputFile
   * @exception FileNotFoundException, IOException
   */
  public static void compressFile(
      File inputFile, File outputFile ) throws
      Exception {


    BufferedInputStream in = null;
    GZIPOutputStream out = null;

    try {

      in = new BufferedInputStream( new FileInputStream(inputFile));

      out = new GZIPOutputStream( new FileOutputStream(outputFile));

      byte buffer[] = new byte[1024];
      int bytesRead;
      while ( (bytesRead = in.read(buffer)) != -1) {
        out.write(buffer, 0, bytesRead);
      }

    }  catch (Exception e) {
      throw e;
    } finally {
      try { in.close(); } catch( Exception e) {}
      try { out.close(); } catch( Exception e) {}
    }
  }


  /**
   * @param fileInputStream
   * @param outputFile
   * @exception FileNotFoundException, IOException
   */
  public static void compressFile(
      FileInputStream fileInputStream, File outputFile ) throws
      Exception {

    BufferedInputStream in = null;
    GZIPOutputStream out = null;
    try {

      in = new BufferedInputStream(fileInputStream);

      out = new GZIPOutputStream( new FileOutputStream(outputFile));

      byte buffer[] = new byte[1024];
      int bytesRead;
      while ( (bytesRead = in.read(buffer)) != -1) {
        out.write(buffer, 0, bytesRead);
      }
    }  catch (Exception e) {
      throw e;
    } finally {
      try { in.close(); } catch( Exception e) {}
      try { out.close(); } catch( Exception e) {}
    }
  }


}
