// $Id: document.h 3546 2005-04-03 08:30:29Z jz $

//-----------------------------------------------------------------------------------------Document

struct Document : idispatch_implementation< Document, Idocument >,
                  registered<Document>,
                  My_thread_only
{
    static Class_descriptor     class_descriptor;


                                Document                    ( Template* );
                                Document                    ( Session*, int id );
                                Document                    ( Document* parent_document, Template* );
                                Document                    ( Document* parent_document, int index );
                                Document                    ( Document* parent_document, hostole::Record );
                               ~Document                    ();

    void                        init                        ();
    void                        close                       ();
    void                        init_subdocument_from_record( hostole::Record );
    int                         id                          () const;
    string                      obj_name                    () const;
    void                        store                       ();
    void                        store_postprocessing_orders ( Transaction* );
    Postprocessing_order_register*  postprocessing_order_register( const string& type_name );
    int                         postprocess_order_get_new_id();
    string                      parameters_filename         ();
    int                         real_head_id                ();
    string                      head_filename               ();
    string                      blob_filename               ( Blob_nr_code nr, bool commit = false ){ return _session->blob_filename( blob_object_document  , id(), nr, "", commit ); }
    User*                       owner                       ();
    Template*                   get_template                ();
    hostole::Variables          parameters                  ();

  //const string&               dialog_script               ();
    
    Iscript_object*             dialog_script_object_or_null( int index );

    int                         number_of_subdocuments      ();
    Document*                   subdocument                 ( int index );

    bool                        is_subdocument              () const                                { return _subdocument_index > 0; }
    Document*                   parent_document             ();
    void                        process_subdocument         ( const hostole::Factory_processor& );



    STDMETHODIMP            get_Debug_state                 ( BSTR* result )                        { return String_to_bstr( obj_name(), result ); }

    STDMETHODIMP                Close                       ();

    STDMETHODIMP            get_Session                     ( Isession** result )                   { *result = _session.copy();  return S_OK; }

    STDMETHODIMP            get_Template                    ( Itemplate** );

  //STDMETHODIMP            get_Template_id                 ( int** result );

    STDMETHODIMP            get_Owner                       ( Iuser** );

    STDMETHODIMP            get_Id                          ( int* );

    STDMETHODIMP            put_Title                       ( BSTR title )                          { Z_COM_MY_THREAD_ONLY;  return Bstr_to_string( title, &_title ); }
    STDMETHODIMP            get_Title                       ( BSTR* result )                        { Z_COM_MY_THREAD_ONLY;  return String_to_bstr( _title, result ); }

    STDMETHODIMP            put_Head_id                     ( int head_id )                         { Z_COM_MY_THREAD_ONLY;  _head_id = head_id;  return S_OK; }
    STDMETHODIMP            get_Head_id                     ( int* result )                         {                        *result = _head_id;  return S_OK; }

    STDMETHODIMP            put_Language                    ( BSTR language )                       { Z_COM_MY_THREAD_ONLY;  return Bstr_to_string( language, &_language ); }
    STDMETHODIMP            get_Language                    ( BSTR* result )                        { Z_COM_MY_THREAD_ONLY;  return String_to_bstr( _language, result ); }

    STDMETHODIMP            get_Parameters                  ( Ivariables2** result );
    STDMETHODIMP         putref_Parameters                  ( Ivariables2* );

    STDMETHODIMP            put_Parameter                   ( BSTR name, VARIANT* value );
    STDMETHODIMP            get_Parameter                   ( BSTR name, VARIANT* result );

    STDMETHODIMP            put_Param                       ( BSTR name, VARIANT* value );
    STDMETHODIMP            get_Param                       ( BSTR name, VARIANT* result )          { return get_Parameter( name, result ); }

      //HRESULT                 Copy_parameters_from        ( [in] Idocument* other_document );

    STDMETHODIMP            put_Filename                    ( BSTR );

    STDMETHODIMP            put_Path                        ( BSTR path )                           { Z_COM_MY_THREAD_ONLY;  return Bstr_to_string( path, &_path ); }
    STDMETHODIMP            get_Path                        ( BSTR* result )                        { Z_COM_MY_THREAD_ONLY;  return String_to_bstr( _path, result ); }

    STDMETHODIMP            put_State                       ( int state )                           { Z_COM_MY_THREAD_ONLY;  _state = state;  return S_OK; }
    STDMETHODIMP            get_State                       ( int* result )                         { *result = _state;  return S_OK; }

    STDMETHODIMP            put_State_text                  ( BSTR t )                              { Z_COM_MY_THREAD_ONLY;  return Bstr_to_string( t, &_state_text ); }
    STDMETHODIMP            get_State_text                  ( BSTR* result )                        { Z_COM_MY_THREAD_ONLY;  return String_to_bstr( _state_text, result ); }

    STDMETHODIMP                Store                       ();

    STDMETHODIMP            get_Dialog_script_object_or_null( int index, Iscript_object** );

    STDMETHODIMP            put_Focus                       ( BSTR focus )                          { Z_COM_MY_THREAD_ONLY;  return Bstr_to_string( focus, &_focus ); }
    STDMETHODIMP            get_Focus                       ( BSTR* result )                        { Z_COM_MY_THREAD_ONLY;  return String_to_bstr( _focus, result ); }

    STDMETHODIMP                Set_message                 ( BSTR message )                        { return put_Message( message ); }
    STDMETHODIMP            put_Message                     ( BSTR message )                        { Z_COM_MY_THREAD_ONLY;  return Bstr_to_string( message, &_message ); }
    STDMETHODIMP            get_Message                     ( BSTR* result )                        { Z_COM_MY_THREAD_ONLY;  return String_to_bstr( _message, result ); }

    STDMETHODIMP            put_Show_again                  ( VARIANT_BOOL show_again )             { _show_again = show_again? true : false;  return S_OK; }
    STDMETHODIMP            get_Show_again                  ( VARIANT_BOOL* result )                { *result = _show_again;     return S_OK; }

    STDMETHODIMP                Create_processor            ( Ifactory_processor** );

    STDMETHODIMP                Process                     ();

    STDMETHODIMP                Template_filename           ( VARIANT*, BSTR* );

    STDMETHODIMP                Text_filename               ( VARIANT*, BSTR* );

    STDMETHODIMP                Create_postprocessing_order ( BSTR type, Ipostprocessing_order** );

    STDMETHODIMP            get_Postprocessing_order        ( BSTR type, int number, Ipostprocessing_order** );

    STDMETHODIMP            put_Workflow_id                 ( int workflow_id )                     { _workflow_id = workflow_id;  return S_OK; }

    STDMETHODIMP            get_Workflow_id                 ( int* result )                         { *result = _workflow_id;  return S_OK; }

  //STDMETHODIMP                Add_form                    ( Iform* );

    STDMETHODIMP                Add_form_id                 ( int );

    STDMETHODIMP                Head_filename               ( VARIANT*, BSTR* );

    STDMETHODIMP                Add_new_document            ( VARIANT*, Idocument** );

    STDMETHODIMP            get_Number_of_documents         ( int* );

    STDMETHODIMP            get_Document                    ( int, Idocument** );

    STDMETHODIMP                Delete_documents            ();


  private:
    Fill_zero                  _zero_;
    Table_descriptor*          _table;           
    bool                       _new;
    int                        _template_id;
    ptr<Template>              _template;
    int                        _head_id;
    int                        _owner_id;
    ptr<User>                  _owner;
    hostole::Variables         _parameters;                 // NULL: Noch nicht geladen. Es gibt eine Variablenmenge, auch wenn sie leer ist.
    string                     _language;
    string                     _title;
    int                        _state;
    string                     _state_text;
    string                     _path;
    int                        _workflow_id;
    string                     _focus;
    string                     _message;
    bool                       _show_again;

    int                        _subdocument_index;          // == 0, wenn kein Subdokument
    Document*                  _parent_document;            // Zirkel! _subdocument_index && !_parent_document => Elterndokument ist geschlossen worden
    bool                       _delete_subdocuments;

    bool                       _has_subdocuments;
    bool                       _number_of_subdocuments_known;
    object_register< Document >_subdocuments_register;
    vector< ptr<Document> >    _subdocuments;

  //string                     _dialog_script;
  //bool                       _dialog_sript_loaded;
    vector<hostole::Script_object> _dialog_script_objects;
    vector<bool>                   _dialog_script_objects_loaded;

    vector< int >              _form_ids;
    vector< ptr<Form> >        _forms;

    typedef map< string, ptr<Postprocessing_order_register> >  Postprocessing_order_registers;   // type ->
    Postprocessing_order_registers                            _postprocessing_order_registers;

    hostole::Factory_processor _processor;                  // Zwischen Create_processor() und Process().
    //typedef map< string, int >    Postprocess_order_new_ids;
    //Postprocess_order_new_ids    _postprocess_order_new_ids;

    //typedef list< ptr<Postprocessing_order> >  Postprocessing_order_list;
    //Postprocessing_order_list   _postprocessing_order_list;
};

//-------------------------------------------------------------------------------------------------

