// $Id: form.cxx 3546 2005-04-03 08:30:29Z jz $

#include "document_factory.h"


namespace sos {
namespace document_factory {

//-------------------------------------------------------------------------------------------static

Form::Class_descriptor          Form::class_descriptor      ( &typelib, "sos.DocumentFactory.Form" );

//---------------------------------------------------------------------------------Form::Form

Form::Form( Session* session, const VARIANT& id_or_path )
:
    Idispatch_implementation( &class_descriptor ),
    Registered( session ),
    _zero_(this+1)
{
/*
    if( is_path( id_or_path ) )
    {
        load( string_from_variant( id_or_path ) );
    }
    else
    if( is_id( id_or_path ) )  
    {
        int id = int_from_variant( id_or_path );
        register_object( id );
    }
    else
        throw_xc( "FACTORY-1006", string_from_variant(id_or_path) );
*/


    string stmt = "select `id`, `path`, `leaf`, `title`  from LF_FORMS  where ";
    
    if( is_path( id_or_path ) )  stmt += "`normalized_path`=" + sql::quoted( normalized_path( string_from_variant( id_or_path ) ) );
    else
    if( is_id  ( id_or_path ) )  stmt += "`id`=" + string_from_variant( id_or_path );
    else 
        throw_xc( "FACTORY-1007" );

    hostole::Record record = _session->db_get_single_or_null( stmt );
    if( !record )  throw_xc( "FACTORY-1008", string_from_variant( id_or_path ), "Formular" );

    int id   = record.as_int   ( "id"       );
    _path    = record.as_string( "path"     );
    _title   = record.as_string( "title"    );

    _normalized_path = normalized_path( _path );

    if( !record.as_bool( "leaf" ) )  throw_xc( "FACTORY-1006", _path, "Formular" );

    register_object( id );
}

//--------------------------------------------------------------------------------------Form::~Form

Form::~Form()
{
    Z_LOGI2( "factory", __PRETTY_FUNCTION__ << "()  " << _path << "\n" );

    try
    {
        close();
    }
    catch( const exception& x )  { Z_LOG2( "factory",  __FUNCTION__ << ": " << x << "\n" ); }
}

//--------------------------------------------------------------------------------------Form::close

void Form::close()
{
}

//-----------------------------------------------------------------------------------Form::obj_name

string Form::obj_name() const
{ 
    string result = "Formular " + as_string( id() ) + " " + _path;
    return result;
}

//---------------------------------------------------------------------------------------Form::load
/*
void Form::load( const string& path )
{
    if( !_loaded )
    {
    / *
        string stmt = "select id, path, leaf, title  from LF_FORMS  where ";
        
        if( is_path( id_or_path ) )  stmt += "normalized_path=" + sql::quoted( normalized_path( string_from_variant( id_or_path ) ) );
        else
        if( is_id  ( id_or_path ) )  stmt += "id=" + string_from_variant( id_or_path );
        else 
            throw_xc( "FACTORY-1007" );

        hostole::Record record = _session->db_get_single_or_null( stmt );
        if( !record )  throw_xc( "FACTORY-1008", string_from_variant( id_or_path ) );

        int id   = record.as_int   ( "id"       );
        _path    = record.as_string( "path"     );
        _title   = record.as_string( "title"    );

        _normalized_path = normalized_path( _path );

        if( !record.as_bool( "leaf" ) )  throw_xc( "FACTORY-1006", _path );
    * /

        _loaded = true;
    }
}
*/
//------------------------------------------------------------------------------Form::dialog_script

const string& Form::dialog_script()
{
    if( !_dialog_script_read )
    {
        try
        {
            _dialog_script = _session->string_from_blob_or_empty( blob_object_form, id(), blob_nr_form_dialog_script, "" );
            _dialog_script_read = true;
        }
        catch( Xc& x )  { x.append_text( __FUNCTION__ );  throw; }
    }

    return _dialog_script;
}

//--------------------------------------------------------------------------------Form::flush_cache

void Form::flush_cache()
{
    _dialog_script_read = false;
    _dialog_script = "";
}

//--------------------------------------------------------------------------------------Form::Close

STDMETHODIMP Form::Close()
{
    Z_LOGI2( "factory", __PRETTY_FUNCTION__ << "()\n" );
    
    HRESULT hr = S_OK;

    try
    {
        close();
    }
    catch( const exception&  x )  { hr = Set_excepinfo( x, __FUNCTION__ ); }
    catch( const _com_error& x )  { hr = Set_excepinfo( x, __FUNCTION__ ); }

    return hr;
}

//----------------------------------------------------------------------------------Form::get_Owner
/*
STDMETHODIMP Form::get_Owner( Iuser** result )
{
    Z_LOGI2( "factory", __PRETTY_FUNCTION__ << "()\n" );
    return E_NOTIMPL;

    HRESULT hr = S_OK;

    try
    {

    }
    catch( const exception&  x )  { hr = Set_excepinfo( x, __FUNCTION__ ); }
    catch( const _com_error& x )  { hr = Set_excepinfo( x, __FUNCTION__ ); }

    return hr;
}
*/
//--------------------------------------------------------------------------Form::get_Dialog_script

STDMETHODIMP Form::get_Dialog_script( BSTR* result )
{
    Z_LOGI2( "factory", __PRETTY_FUNCTION__ << "()\n" );

    HRESULT hr = S_OK;

    try
    {
        hr = String_to_bstr( dialog_script(), result );
    }
    catch( const exception&  x )  { hr = Set_excepinfo( x, __FUNCTION__ ); }
    catch( const _com_error& x )  { hr = Set_excepinfo( x, __FUNCTION__ ); }

    return hr;
}

//-------------------------------------------------------------------------------------------------

} //namespace document_factory
} //namespace sos
