// $Id: postprocessing_order.h 3546 2005-04-03 08:30:29Z jz $

//-----------------------------------------------------------------------------Postprocessing_order

struct Postprocessing_order : idispatch_implementation< Postprocessing_order, Ipostprocessing_order>,
                              registered<Postprocessing_order>,
                              My_thread_only
{
    static Class_descriptor     class_descriptor;


                                Postprocessing_order        ( Postprocessing_order_type*, Document* );
                                Postprocessing_order        ( Postprocessing_order_type*, Document*, int id );
                               ~Postprocessing_order        ();

    void                        close                       ();
    string                      obj_name                    () const;
    void                        store                       ( Transaction* );


    STDMETHODIMP            get_Debug_state                 ( BSTR* result )                        { return String_to_bstr( obj_name(), result ); }

    STDMETHODIMP                Close                       ();

    STDMETHODIMP            get_Session                     ( Isession** result )                   { *result = _session.copy();  return S_OK; }

    STDMETHODIMP            get_Document                    ( Idocument** result )                  { *result = _document.copy();  return S_OK; }

    STDMETHODIMP            get_Number                      ( int* result )                         { *result = id();  return S_OK; }

    STDMETHODIMP            put_Attribute                   ( BSTR name, VARIANT* value );
    STDMETHODIMP            get_Attribute                   ( BSTR name, VARIANT* result );

  private:
    Fill_zero                  _zero_;

    ptr<Document>              _document;
    ptr<Postprocessing_order_type> _type;
    bool                       _new;

    typedef map< string, Variant >  Attributes;
    Attributes                 _attributes;
};

//------------------------------------------------------------------------Postprocessing_order_type

struct Postprocessing_order_type : Object
{
                                Postprocessing_order_type   ( Session* s, const string& name, const sql::Table_descriptor& table ) : _zero_(this+1), _session(s), _name(name), _table(table) {}

    void                        init                        ();
    void                        close                       ()                                      { _session = NULL; }
    void                        check_attribute_name        ( const string& );

    Fill_zero                  _zero_;
    ptr<Session>               _session;
    string                     _name;
    sql::Table_descriptor      _table;
    set<string>                _field_names;
    bool                       _initialized;
};

//--------------------------------------------------------------------Postprocessing_order_register

struct Postprocessing_order_register : object_register< Postprocessing_order >
{
                                Postprocessing_order_register() : _new_id( 0 )  {}

    int                        _new_id;
};

//-------------------------------------------------------------------------------------------------

