// $Id: session.h 3546 2005-04-03 08:30:29Z jz $

//------------------------------------------------------------------------------------------Session

struct Session : idispatch_implementation< Session, Isession >,
                 My_thread_only
{
    static Class_descriptor     class_descriptor;




                                Session                     ( Factory*, const string& unit, const string& user, const string& password );
                               ~Session                     ();

    void                        close                       ();


    STDMETHODIMP_(ULONG)        AddRef                      ()                                      { return Idispatch_implementation::AddRef(); }
    STDMETHODIMP_(ULONG)        Release                     ()                                      { return Idispatch_implementation::Release(); }

    template< class CLASS >
    inline object_register<CLASS>* get_register             ( CLASS* );                             // Nur die Spezialisierungen sind implementiert.

    object_register<User>*      get_register                ( User* )                               { return &_user_register; }
    object_register<Head>*      get_register                ( Head* )                               { return &_head_register; }
    object_register<Template>*  get_register                ( Template* )                           { return &_template_register; }
    object_register<Text>*      get_register                ( Text* )                               { return &_text_register; }
    object_register<Document>*  get_register                ( Document* )                           { return &_document_register; }
    object_register<Form>*      get_register                ( Form* )                               { return &_form_register; }

    Postprocessing_order_type*  add_postprocessing_order_type( const string& type_name, const string& table_name );
    Postprocessing_order_type*  postprocessing_order_type   ( const string& type_name );


    int                         id_of_path                  ( const string&, const Table_descriptor& );
    int                         id_of_path                  ( const VARIANT&, const Table_descriptor& );
    int                         db_execute                  ( const string& stmt );
    void                        db_execute_single           ( const string& update_stmt );
    hostole::Record             db_get_single               ( const string& select_stmt );
    hostole::Record             db_get_single_or_null       ( const string& select_stmt );
    Variant                     db_get_single_value         ( const string& select_stmt )           { return db_get_single( select_stmt )[ 0 ]; }
    string                      blob_name                   ( Blob_object_code, int id, Blob_nr_code, string rest );
    string                      blob_filename               ( Blob_object_code, int id, Blob_nr_code, string rest, bool commit = false );
    string                      string_from_blob_or_empty   ( Blob_object_code o, int id, Blob_nr_code n, const string& rest )  { return _hostware.file_as_string_or_empty( blob_filename( o, id, n, rest ) ); }
    void                        insert_blob                 ( Blob_object_code o, int id, Blob_nr_code n, const string& rest, const string& value )  { insert_or_update_blob( o, id, n, rest, value, true ); }
    void                        update_blob                 ( Blob_object_code o, int id, Blob_nr_code n, const string& rest, const string& value )  { insert_or_update_blob( o, id, n, rest, value, false ); }
    void                        insert_or_update_blob       ( Blob_object_code o, int id, Blob_nr_code n, const string& rest, const string& value, bool insert );
  //string                      setting_filename            ( const string& name );

    User*                       user                        ()                                      { return _user; }
    ptr<User>                   user                        ( const VARIANT& id_or_path );
    ptr<User>                   user                        ( const Variant& id_or_path )           { return user( static_cast< const VARIANT& >( id_or_path ) ); }
    ptr<User>                   user                        ( const string& unit, const string& name, const string& password );

    ptr<Head>                   head                        ( const VARIANT& path_or_id );
    ptr<Template>           get_template                    ( const VARIANT& path_or_id );
    ptr<Text>                   text                        ( const VARIANT& path_or_id );
    ptr<Document>               document                    ( int id );
    ptr<Form>                   form                        ( const VARIANT& path_or_id );
    ptr<Form>                   form                        ( const Variant& path_or_id )           { return form( static_cast<const VARIANT&>( path_or_id ) ); }
    string                      start_script                ( const string& script_language );


    STDMETHODIMP            get_Debug_state                 ( BSTR* result );

    STDMETHODIMP                Close                       ();

    STDMETHODIMP            get_Db_name                     ( BSTR* result )                        { Z_COM_MY_THREAD_ONLY;  return String_to_bstr( rtrim( _db_name ), result ); }

    STDMETHODIMP            get_Db                          ( Ihostware_file** result )             { Z_COM_MY_THREAD_ONLY;  *result = _db.copy();  return S_OK; }

    STDMETHODIMP            put_Use_cache                   ( VARIANT_BOOL use_cache );
    STDMETHODIMP            get_Use_cache                   ( VARIANT_BOOL* result );

    STDMETHODIMP                Flush_cache                 ();

    STDMETHODIMP                Head_id_of_path             ( BSTR path, int* result );

    STDMETHODIMP                Template_id_of_path         ( BSTR path, int* result );

    STDMETHODIMP                Text_id_of_path             ( BSTR path, int* result );

    STDMETHODIMP                Form_id_of_path             ( BSTR path, int* result );

    STDMETHODIMP            get_User                        ( VARIANT*, Iuser** result );

    STDMETHODIMP            get_Template                    ( VARIANT*, Itemplate** );

    STDMETHODIMP            get_Form                        ( VARIANT*, Iform** );

    STDMETHODIMP            get_Document                    ( int id, Idocument** );

    STDMETHODIMP                Create_document             ( VARIANT* template_name_or_id, Idocument** );

    STDMETHODIMP                Load_document               ( int id, Idocument** );

    STDMETHODIMP                Check_script                ( BSTR script, BSTR language );

    STDMETHODIMP                Normalized_path             ( BSTR path, BSTR* result );

    STDMETHODIMP            put_Add_parameters_as_variables_in_dialog_scripts( VARIANT_BOOL value )  { _add_parameters_as_variables_in_dialog_scripts = value != 0;  return S_OK; }

    Fill_zero                  _zero_;
    ptr<Factory> const         _factory;
    sos::hostole::Hostware const _hostware;
    sos::hostole::File         _db;
    Transaction*               _current_inner_transaction;
    sql::Database_descriptor   _db_descr;
    Table_descriptor           _head_table;
    Table_descriptor           _template_table;
    Table_descriptor           _text_table;
    Table_descriptor           _form_table;
    Table_descriptor           _documents_table;
    Table_descriptor           _blobs_table;
    Table_descriptor           _settings_table;
    Table_descriptor           _subdocuments_table;

    string                     _db_name;
    string                     _use_cache_prefix;           // "" oder "cache | "
    Settings                   _settings;
    bool                       _add_parameters_as_variables_in_dialog_scripts;

    object_register<User>      _user_register;
    object_register<Head>      _head_register;
    object_register<Template>  _template_register;
    object_register<Text>      _text_register;
    object_register<Document>  _document_register;
    object_register<Form>      _form_register;

    typedef map< string, ptr<Postprocessing_order_type> >  Postprocessing_order_types;   // type ->
    Postprocessing_order_types                            _postprocessing_order_types;
  private:
    ptr<User>                  _user;
    string                     _start_script;
    bool                       _start_script_read;

};

//-------------------------------------------------------------------------------------------------
