// $Id: standard.h 3546 2005-04-03 08:30:29Z jz $

//-------------------------------------------------------------------------------------------------

struct Factory;
struct Session;
struct Head;
struct Template;
struct Text;
struct Document;
struct Form;
struct User;
struct Postprocessing_order;
struct Postprocessing_order_type;
struct Postprocessing_order_register;

//-------------------------------------------------------------------------------------------static

extern Mutex                    document_factory_mutex;
extern Typelib_ref              typelib;

//--------------------------------------------------------------------------------enum Templat_kind

enum Template_kind
{
    template_kind_none          = 0,
    template_kind_head          = 1,
    template_kind_template      = 2,
    template_kind_text          = 3
};

//----------------------------------------------------------------------------enum Blob_object_code

enum Blob_object_code           // Codes fr Tabelle lf_blobs.object
{
    blob_object_template        = 1,    // Dokumentvorlagen
    blob_object_text            = 2,    // Textbausteine
    blob_object_queue           = 3,    // Warteschlangen
    blob_object_printer         = 4,    // Drucker
    blob_object_query           = 5,    // Abfragen
    blob_object_form            = 6,    // Formulare
    blob_object_document        = 7,    // Dokumente
    blob_object_head            = 9,    // Briefbgen
  //blob_object_parameters      = 10    // Dokumentparameter (XML)
};


//--------------------------------------------------------------------------------enum Blob_nr_code

enum Blob_nr_code               // Codes fr Tabelle lf_blobs.nr
{
    // Fr blob_object_template:
    blob_nr_template_text           = 1,        // Vorlagentext (RTF)
    blob_nr_template_forerun_script = 2,        // Vorlaufskript
    blob_nr_template_dialog_script  = 3,        // Dialogskript mit Init- und Plausimethode
    blob_nr_template_archivscript   = 4,        // Vorlagenspezifische Archivierung
    blob_nr_template_asp_main       = 5,        // Vorlage.asp (Vorlagensteuerung)
    blob_nr_template_asp_help       = 6,        // Vorlage_help.asp (Hilfetext)
    blob_nr_template_asp_js         = 7,        // Vorlage.js (JavaScript)
    blob_nr_template_asp_mask       = 8,        // Vorlage_mask.asp (Formular)

    // Fr blob_object_document:
    blob_nr_document_parameters     = 701,      // Dokumentparameter (XML)

    // Fr blob_object_head:
  //blob_nr_head_head               = 1,         // Vorlagentext (RTF) des Briefbogens

    // Fr blob_object_form:
    blob_nr_form_dialog_script      = 5,        // Formular-Dialogskript
};

//--------------------------------------------------------------------------------------------const

//const int use_factorys_head_id      = -1;
const int use_users_head_id         = -2;       // Der Briefbogen des Benutzers soll verwendet werden.
//const int use_groups_head_id        = -3;     // Der Briefbogen der Unit soll verwendet werden.
const int use_no_head_id            = -99;

/*
enum Blob_Factory_blob_variables
    fbv_start_script = 1
    fbv_template_rtf = 2
    fbv_text_rtf = 3
    fbv_asp_generator = 4
End Enum
*/
//-------------------------------------------------------------------------------------------------

string                          normalized_path             ( const string& );
bool                            equal_paths                 ( const string&, const string& );
inline bool                     is_id                       ( const VARIANT& id_or_path )           { return variant_is_integer( id_or_path ); }
inline bool                     is_path                     ( const VARIANT& id_or_path )           { return ( id_or_path.vt & VT_TYPEMASK ) == VT_BSTR; }
string                          left_align                  ( const string& value, int length );
string                          left_align                  ( int value, int length );

//--------------------------------------------------------------------------------------Transaction

struct Transaction 
{
                                Transaction                 ( Session* );
                               ~Transaction                 ();

    void                        commit                      ();
    void                        rollback                    ();

    Session*                   _session;
    Transaction*               _outer_transaction;
};

//---------------------------------------------------------------------------------Table_descriptor

struct Table_descriptor : sql::Table_descriptor
{
                                Table_descriptor            ( const sql::Database_descriptor* db, const char* table_name, const char* key_names, const char* object_name ) 
                                                                                                : sql::Table_descriptor( db, table_name, key_names ), _object_name(object_name) {}

    string                     _object_name;                // Klarname des Objekts, z.B. "Vorlage"
};

/*
const extern Table_descriptor head_table;
const extern Table_descriptor template_table;
const extern Table_descriptor text_table;
const extern Table_descriptor form_table;
const extern Table_descriptor documents_table;
*/
//--------------------------------------------------------------------------------object_register<>
// Im object_register sind Objekte registriert.
// Session hat drei object_register fr User, Template und Document.
// Damit wird erreicht, dass kein Objekt doppelt geladen wird.
// Die Objekte haben einen ptr<>-Verweis auf Session, Session sollte aber keinen auf die Objekte (sonst Zirkel).

template< class CLASS >
struct object_register : Object
{
    typedef stdext::hash_multimap< int, CLASS* >  Id_map;
  //typedef stdext::multihash_map< string, CLASS* >  Path_map;


    object_register()
    : 
        _unique(true) 
    {
    }



    void close()
    {
        //Id_map copy = _id_map;

        //for( typename Id_map::iterator it = copy.begin(); it != copy.end(); it++ )
        for( typename Id_map::iterator it = _id_map.begin(); it != _id_map.end(); it++ )
        {
            if( it->second )  
            {
                Z_LOGI2( "factory", "Offenes Objekt wird geschlossen: " << it->second->obj_name() << "\n" );

                try
                {
                    //ptr<CLASS> object = it->second;    // Close() kann das Objekt zu frh auflsen, also Objekt festhalten
                    CLASS* object = it->second;
                    static_cast< registered<CLASS>* >( object )->_id = 0;
                    object->Close();
                }
                catch( const exception& x )  { Z_LOG( x << "\n" ); }
            }
        }

        _id_map.clear();   // jz 13.7.04
    }


    void register_object( int id, CLASS* object )
    { 
        if( id <= 0 )  throw_xc( "FACTORY-1011", id );
        
        if( _unique  &&  _id_map.find( id ) != _id_map.end() )  throw_xc( "FACTORY-1801", id );
        _id_map.insert( Id_map::value_type( id, object ) ); 
    }


    void unregister_object( int id, CLASS* object )
    { 
        for( typename Id_map::iterator it = _id_map.find( id ); it != _id_map.end(); it++ )
        {
            if( it->first == id  &&  it->second == object )  { _id_map.erase( it );  break; }
        }
    }


    string state_text()
    {
        string result;

        for( typename Id_map::iterator it = _id_map.begin(); it != _id_map.end(); it++ )
        {
            if( it->second )
            {
                result += it->second->obj_name();
                result += "\n";
            }
        }

        return result;
    }


    CLASS* operator[] ( int id ) const
    { 
        Z_LOG2( "factory", __PRETTY_FUNCTION__ << "(int " << id << ")\n" );
        typename Id_map::const_iterator it = _id_map.find( id );  
        return it == _id_map.end()? NULL 
                                  : it->second; 
    }


    CLASS* operator[] ( const string& path ) const
    { 
        string npath = normalized_path( path );
        Z_LOG2( "factory", __PRETTY_FUNCTION__ << "(\"" << npath << "\")\n" );
        Z_FOR_EACH_CONST( typename Id_map, _id_map, i)  
            if( i->second->_normalized_path == npath )  return i->second;  
        return NULL; 
    }


    CLASS* operator[] ( const VARIANT& id_or_path ) const
    { 
        if( is_path( id_or_path ) )  return operator[]( string_from_variant( id_or_path ) );
        if( is_id  ( id_or_path ) )  return operator[]( int_from_variant   ( id_or_path ) );
        throw_xc( "FACTORY-1007" ); 
    }


    Id_map                     _id_map;
  //Path_map                   _path_map;
    bool                       _unique;
};

//-------------------------------------------------------------------------------------registered<>
// Diese Oberklasse lsst ein Objekt registrieren und beim Destruieren wieder deregistrieren.

template< class SUBCLASS >
struct registered
{
    typedef registered<SUBCLASS>       Registered;
    typedef object_register<SUBCLASS>  Register;


                                registered                  ( Session* session )                    : _session(session), _id(0), _register( _session->get_register( (SUBCLASS*)NULL ) ) {}
                                registered                  ( Session* session, int id )            : _session(session), _id(0), _register( _session->get_register( (SUBCLASS*)NULL ) )  { register_object( id ); }
                                registered                  ( Session* session, Register* reg )     : _session(session), _id(0), _register(reg)  {}
                                registered                  ( Session* session, Register* reg, int id ): _session(session), _id(0), _register(reg)  { register_object( id ); }
                               ~registered                  ()                                      { unregister_object(); }

    void                        register_object             ( int id )                              { unregister_object(); _register->register_object  ( id, static_cast<SUBCLASS*>( this ) ); _id = id; }
    void                        unregister_object           ()                                      { if( _id )            _register->unregister_object( _id, static_cast<SUBCLASS*>( this ) ), _id = 0; }
    int                         id                          () const                                { return _id; }
  //void                        registered_close            ()                                      { _id = 0; }   //?


    ptr<Session> const         _session;
  private:
    friend struct Register;
    Register*                  _register;
    int                        _id;
};

//---------------------------------------------------------------------------------String_from_file
/*
struct String_from_file
{
                                String_from_file            ( Session* s, const string& filename, const string& title );

    const string&               get                         ();
                                operator const string&      ()                                      { return get(); }


    hostole::Hostware          _hostware;
    string                     _filename;
    bool                       _read;
    string                     _title;
    string                     _string;
};
*/
//-----------------------------------------------------------------------------------------Settings

struct Settings
{
                                Settings                    ( Session* session )                    : _session(session) {}

  //void                        path_to_names               ( const string& path, string* application, string* section, string* name );
  //void                        path_to_names               ( const string& path, vector<string>* );
    vector<string>              names_from_path             ( const string& path );
    string                      where                       ( const string& path );

    string                      get                         ( const string& path );
    string                      get_with_default            ( const string& path, const string& deflt );
    int                         get_int                     ( const string& path );
    string                      get_blob                    ( const string& path );
    string                      get_blob_or_default         ( const string& path, const string& deflt );
    void                        insert                      ( const string& path, int value )       { insert( path, as_string( value ) ); }
    void                        insert                      ( const string& path, const string& );
    int                         get_new_id                  ( const Table_descriptor& );

    Session*                   _session;
    string                     _application_default;
};

//-------------------------------------------------------------------------------------------------

