// $Id: template_base.h 3546 2005-04-03 08:30:29Z jz $

//------------------------------------------------------------------------------------Template_base

struct Template_base : idispatch_implementation< Template_base, Itemplate >,
                       My_thread_only
{
    static Class_descriptor     class_descriptor;


                                Template_base               ( Session*, Template_kind, const Table_descriptor*, const VARIANT& id_or_path );
    virtual                    ~Template_base               ();


  //virtual void                register_object             ( int id )                              = 0;
  //virtual void                unregister_object           ( int id, Template_base* )              = 0;
    int                         id                          () const                                { return _id; }

    void                        close                       ();
    string                      obj_name                    () const;
    const string&               dialog_script               ();
    const string&               forerun_script              ();
    string                      template_filename           ( const string& language, bool commit = false )  { return blob_filename( blob_nr_template_text, language, commit ); }
    string                      blob_filename               ( Blob_nr_code nr, string language, bool commit = false );
    Form*                       form                        ( int index );
    void                        load_form_ids               ();
    int                         form_count                  ()                                      { load_form_ids();  return (int)_forms.size(); }
    void                        flush_cache                 ();


    STDMETHODIMP            get_Debug_state                 ( BSTR* result )                        { return String_to_bstr( obj_name(), result ); }

    STDMETHODIMP                Close                       ();

    STDMETHODIMP            get_Session                     ( Isession** result )                   { *result = _session.copy();  return S_OK; }

    STDMETHODIMP            get_Id                          ( int* result )                         { Z_COM_MY_THREAD_ONLY;  *result = id();  return S_OK; }

    STDMETHODIMP            get_Path                        ( BSTR* result )                        { Z_COM_MY_THREAD_ONLY;  return String_to_bstr( _path, result ); }

  //STDMETHODIMP            get_Owner                       ( Iuser** result );

    STDMETHODIMP            get_Form                        ( int, Iform** result );

    STDMETHODIMP            get_Forerun_script              ( BSTR* result );

  //STDMETHODIMP            get_Forerun_script_object       ( Iscript_object** result );

    STDMETHODIMP            get_Dialog_script               ( BSTR* result );

  //STDMETHODIMP            get_Dialog_script_object        ( Iscript_object** result );

    STDMETHODIMP                Create_document             ( Idocument** );



    Fill_zero                  _zero_;
    Template_kind              _template_kind;
    const Table_descriptor*    _table_description;
    int                        _id;
    ptr<Factory> const         _factory;
    ptr<Session> const         _session;
  //hostole::Hostware const    _hostware;
  //ptr<User>                  _owner;
    string                     _path;
    string                     _normalized_path;
    string                     _title;
    string                     _type;                       // _text_type + "/" + _script_language
    string                     _text_type;
    string                     _script_language;
    int                        _head_id;
  private:
    vector<int>                _form_ids;
    bool                       _form_ids_loaded;
    vector< ptr<Form> >        _forms;
    vector< bool >             _forms_loaded;
    string                     _forerun_script;
    bool                       _forerun_script_read;
    string                     _dialog_script;
    bool                       _dialog_script_read;
};

//-------------------------------------------------------------------------------------------------
