// $Id: user.h 3546 2005-04-03 08:30:29Z jz $

//---------------------------------------------------------------------------------------------User

struct User : idispatch_implementation< User, Iuser >,
              registered< User >,
              My_thread_only

{
    static Class_descriptor     class_descriptor;


                                User                        ( Session* session, const VARIANT& id_or_path, const string& password, bool password_check );
                                User                        ( Session* session, const string& unit, const string& name, const string& password );
                               ~User                        ();

    void                        close                       ();
    string                      obj_name                    () const;
    void                        load                        ( const string& where, const string& password, bool check_password = true );
    hostole::Variables          parameters                  ();


    STDMETHODIMP            get_Debug_state                 ( BSTR* result )                        { return String_to_bstr( obj_name(), result ); }

    STDMETHODIMP                Close                       ();

    STDMETHODIMP            get_Session                     ( Isession** result )                   { *result = _session.copy();  return S_OK; }
    STDMETHODIMP            get_Id                          ( int* result )                         { *result = id();  return S_OK; }
    STDMETHODIMP            get_Parameters                  ( Ivariables2** );
    STDMETHODIMP            get_Name                        ( BSTR* result )                        { return String_to_bstr( _name     , result ); }
    STDMETHODIMP            get_Full_name                   ( BSTR* result )                        { return String_to_bstr( _full_name, result ); }
    STDMETHODIMP            get_Parent_id                   ( int* result )                         { *result = _parent_id;  return S_OK; }
    STDMETHODIMP            get_Unit                        ( BSTR* result )                        { return String_to_bstr( _unit     , result ); }


    Fill_zero                  _zero_;
    int                        _head_id;
    string                     _normalized_path;
  private:
    string                     _unit;
    int                        _parent_id;
    string                     _name;
    string                     _full_name;
    bool                       _password_checked;
    hostole::Variables         _parameters;
};

//-------------------------------------------------------------------------------------------------
