// $Id: main.cxx 3546 2005-04-03 08:30:29Z jz $

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "../kram/version.h"
#include "../hostole/hostole.h"
#include "../zschimmer/zschimmer.h"
#include "../zschimmer/z_com.h"

using namespace std;
using namespace zschimmer;
using namespace zschimmer::com;


static bool get_opt( const char* arg, const char* option, string* value = NULL )
{
    if( !value  &&  strcmp( arg, option ) == 0 )  return true;

    int len = strlen( option );

    if( strncmp( arg, option, len ) == 0 )  
    {
        *value = arg + len;
        return true;
    }
    else
        return false;
}



int main( int argc, char** argv )
{
    int ret;
    HRESULT hr = NOERROR;

    //?zschimmer_init();
    CoInitialize(NULL);

    try
    {
        HRESULT hr;
        string  template_filename;
        string  output_filename   = "/dev/stderr";
        string  language          = "PerlScript";


        ptr<Ifactory_processor> processor;
        hr = processor.CoCreateInstance( CLSID_Factory_processor );
        if( FAILED(hr) )  throw_com(hr,"CoCreateInstance","hostware.Factory_processor");


        for( int i = 1; i < argc; i++ )
        {
            if( get_opt( argv[i], "-V" ) )  
            { 
                fprintf( stderr, "Document Factory %s\n(C) Software- und Organisations-Service GmbH, http://www.sos-berlin.com\n", VER_PRODUCTVERSION_STR ); 
                continue; 
            }

            if( get_opt( argv[i], "-template=", &template_filename ) )  continue;
            if( get_opt( argv[i], "-output="  , &output_filename   ) )  continue;
            if( get_opt( argv[i], "-language=", &language          ) )  continue;
            
            fprintf( stderr, "Parameter nicht erkannt: %s\n", argv[i] );
            fprintf( stderr, "Usage: %s -V -template=FILENAME -output=FILENAME\n", argv[0] );
            return 1;
        }



        hr = processor->put_language( Bstr( language.c_str() ) );                       if( FAILED(hr) )  throw_com( hr, "Factory_processor::language", language.c_str() );
        hr = processor->put_template_filename( Bstr( template_filename.c_str() ) );     if( FAILED(hr) )  throw_com( hr, "Factory_processor::template", template_filename.c_str() );
        hr = processor->put_document_filename( Bstr( output_filename.c_str() ) );       if( FAILED(hr) )  throw_com( hr, "Factory_processor::document", output_filename.c_str() );

        string script;
        while( !feof(stdin) )
        {
            char buffer [ 1024 ];
            int len = fread( buffer, 1, sizeof buffer, stdin );
            if( len <= 0 )  break;
            script.append( buffer, len );
        }

        hr = processor->parse( Bstr( script.c_str() ), (Scripttext_flags)0, NULL );
        if( FAILED(hr) )  throw_com( hr, "Factory_processor::parse" );
    
      //hr = processor->put_parameter( Bstr("entgelt"), &Variant(1000) );
      //hr = processor->get_parameter( Bstr("x"), &v );
      //hr = processor->eval( Bstr("1"), (Scripttext_flags)0, &vt );

        hr = processor->process();
        if( FAILED(hr) )  throw_com( hr, "Factory_processor::process" );

        ret = 0;
    }
    catch( const exception& x )
    {
        fprintf( stderr, "FEHLER %s\n", x.what() );
        ret = 1;
    }

    CoUninitialize();

    return ret;
}
