// $Id: hostphp.cxx 3546 2005-04-03 08:30:29Z jz $

#include "../kram/sysdep.h"
#include "../kram/sos.h"
#include "../kram/sleep.h"
#include "../kram/thread_data.h"

/*
#include "com.h"


libhostole.so  wegen sos.ini [hostole]
-------------

Kein [hostphp] log= mehr, sondern [hostole]

hostware_global.check_licence( "hostphp" )   prft zustzlich zu licence_hostole.




read_profile_string()
//logfile = hostware.get_single( "select value where lcase(entry)='log' | profile -section=hostphp" )
logfile.open( "log :")
LOG -> logfile.put_line
licence
quoted_string

*/

#ifdef _WINDOWS
#   include <windows.h>

    // Header-Dateien fr php.h:
#   include <ios>
#   include <iostream>
#   include <strstream>
//VC2003 #   include <ios.h>
//VC2003 #   include <streamb.h>
#   include <sstream>
#   include <math.h>    // Fr Microsoft Visual Studio C++ 6

#   define PHP_WIN32
#   define ZEND_WIN32
#   define ZTS          // Thread-safe

#   define EXPORT  _declspec(dllexport)

//  Wie aus php4ts.dll die php4ts.lib erzeugt wird, steht in 
//  http://support.microsoft.com/support/kb/ARTICLES/Q131/3/13.asp
//  (mit Hilfe von dumpbin /exports php4ts.dll >php4ts.def schreiben und mit lib /def:php4ts.def die php4ts.lib erzeugen)

#   include <crtdbg.h>

# else

#   define EXPORT

#endif


#ifdef ZTS   // Thread-safe?
#   define MY_TSRMLS_PARAM      TSRMLS_D
#   define MY_TSRMLS            TSRMLS_C
#else
#   define MY_TSRMLS_PARAM      void*           // Dummy
#   define MY_TSRMLS            NULL
#endif


#include <vector>

#include "../kram/sosappl.h"
#include "../kram/sosprof.h"
#include "../kram/log.h"
#include "../kram/licence.h"
#include "../kram/sosfield.h"
#include "../kram/sosdate.h"
#include "../kram/sosxml.h"
#include "../kram/thread_semaphore.h"
#include "../file/anyfile.h"
#include "../file/stdfile.h"    // file_exists()
#include "hostphp_version.h"


extern "C"
{
//  Folgende Include-Verzeichnisse von PHP mssen in den INCLUDE-Pfad aufgenommen werden:
//  .../php
//  .../php/main
//  .../php/Zend
//  .../php/TSRM

#    ifdef _DEBUG
#        define ZEND_DEBUG 0     // Nur 1, wenn PHP selbst auch mit ZEND_DEBUG bersetzt ist
#     else
#        define ZEND_DEBUG 0
#    endif

#   include "php.h"
//# include "php_ini.h"
#   include "ext/standard/info.h"

#   ifndef PHP_MINIT_FUNCTION
#       error php.h ist nicht korrekt   // Um bei gcc die drei Millionen Fehlermeldungen zu vermeiden, wenn php.h fehlt
#   endif

/*
#   ifndef ZEND_DEBUG
#       ifdef _DEBUG
#           define ZEND_DEBUG 1     // Nur 1, wenn PHP selbst auch mit ZEND_DEBUG bersetzt ist
#        else
#           define ZEND_DEBUG 0
#       endif
#   endif
*/


    //extern "C" int php_info_print_table_start(...);
    //extern "C" int php_info_print_table_row(...);
    //extern "C" int php_info_print_table_end(...);

    extern zend_module_entry hostware_module_entry;
#   define hostware_module_ptr &hostware_module_entry;

    PHP_MINIT_FUNCTION( hostware );
    PHP_MSHUTDOWN_FUNCTION( hostware );
    PHP_RSHUTDOWN_FUNCTION( hostware );
    PHP_MINFO_FUNCTION( hostware );
}

//ofstream logfile( "/tmp/hostphp.log2" ); 

namespace sos {

using namespace std;

//static char*        argv0       = "hostphp";
//char**             _argv        = &argv0;
//int                _argc        = 1;
static Sos_appl     appl        (false);


namespace php {

struct File;
struct Session;

//---------------------------------------------------------------------------------------Registered

struct Registered : Sos_self_deleting
{
    virtual                    ~Registered              ()                                      {}

    int                         index                   ()                                      { return _index; }


    int                        _index;
};

//-----------------------------------------------------------------------------------------Register

struct Register : Registered
{
                                Register                ( const string& name )                  : _name(name) { _array.push_back(NULL); }
                               ~Register                ()                                      { close(); }

    int                         free_index              ();
    int                         add                     ( const Sos_ptr<Registered>& );
    void                        close                   ();
    void                        close_object            ( int index );
    Registered*                 by_index                ( int index );
    Registered*                 by_index                ( zval* index )                         { return by_index( index->value.lval ); }

    virtual string              obj_name                () const                                { return _name; }

    string                     _name;
    vector< Sos_ptr<Registered> > _array;
};

//-------------------------------------------------------------------------------------------Record

struct Record : Registered
{
                                Record                  ( Session*, Record_type* = NULL, File* = NULL );
                                Record                  ( const Record& );
    virtual                    ~Record                  ();

    Record&                     operator =              ( const Record& );

    virtual string             _obj_name                () const;

    string                      as_xml                  ();
    void                        assign                  ( zval* );


    bool                       _write_empty_as_null;

    void                        construct               ();
    void                        finish                  ();     // Nachbearbeitet _type und _record
    Field_descr*                field                   ( zval* field_name );

    Session*                   _session;
    Sos_ptr<Field_type>        _type;
    Dynamic_area               _record;
    Text_format                _text_format;
};

//---------------------------------------------------------------------------------------------File

struct File : Registered
{
                                File                    ( Session* s )                          : _session(s) {}

    Sos_ptr<Record>             get_record_data         ( zval* );
    Sos_ptr<Record>             get_key_data            ( zval* );

    virtual string             _obj_name                () const                                { return "File(" + _any_file.name() + ')'; }

    Session*                   _session;
    Any_file                   _any_file;
    Sos_ptr<Record_type>       _type;
    Sos_ptr<Field_descr>       _key_descr;
    bool                       _write_empty_as_null;
    Text_format                _text_format;
    Sos_string                 _filename_prefix;
    vector<Dyn_obj>            _param_values;           // fr set_parameters()
};

//------------------------------------------------------------------------------------------Session

struct Session : Registered
{
                                Session                 ()                                      : _files("Files"), _records("Records") {}

    virtual string             _obj_name                () const                                { return "Session " + _name; }
    void                        close                   ()                                      { _records.close(); _files.close(); }

    Sos_ptr<Record>             pval_as_record          ( Record_type*, zval* );

    string                     _name;
    Register                   _files;
    Register                   _records;
};

//------------------------------------------------------------------------------Hostphp_thread_data

struct Hostphp_thread_data
{
                                Hostphp_thread_data     ()                                      : _zero_(this+1), _error_mode ( E_WARNING ) {}

    Fill_zero                  _zero_;
    int                        _error_mode;
    Xc*                        _last_xc;
    Session*                   _current_session;
    Dynamic_area               _buffer;
};


static Thread_data<Hostphp_thread_data> thread_data;

//-------------------------------------------------------------------------------------------------

static Thread_semaphore         semaphore               ( "hostphp" );
static Register                 sessions                ( "Sessions" );

//-----------------------------------------------------------------------------------GET_PHP_PARAMS

#define GET_PHP_PARAMS( MIN_COUNT, MAX_COUNT )                                                  \
    assert( MIN_COUNT <= MAX_COUNT );                                                           \
    int    php_param_count = ZEND_NUM_ARGS();                                                   \
    zval** php_params      [ MAX_COUNT ];                                                       \
    if( php_param_count < MIN_COUNT  ||  php_param_count > MAX_COUNT )  WRONG_PARAM_COUNT;      \
    if( zend_get_parameters_array_ex( php_param_count, php_params ) != SUCCESS )  WRONG_PARAM_COUNT;
    
//-------------------------------------------------------------------------------GET_PHP_PARAM_ZVAL

#define GET_PHP_PARAM_ZVAL(NR,NAME)                                                             \
    assert( (uint)NR <= NO_OF(php_params) );                                                    \
    zval* NAME;                                                                                 \
    if( php_param_count >= NR )  NAME = *php_params[NR-1];

//-----------------------------------------------------------------------------GET_PHP_PARAM_STRING

#define GET_PHP_PARAM_STRING(NR,NAME)                                                           \
    assert( (uint)NR <= NO_OF(php_params) );                                                    \
    string NAME;                                                                                \
    if( php_param_count >= NR ) {                                                               \
        if( (*php_params[NR-1])->type != IS_STRING )  throw_xc( "SOS-PHP-103", #NAME, "String" ); \
        NAME.assign( (*php_params[NR-1])->value.str.val, (*php_params[NR-1])->value.str.len );  \
    }

//--------------------------------------------------------------------------GET_PHP_PARAM_AS_STRING

#define GET_PHP_PARAM_AS_STRING(NR,NAME)                                                        \
    assert( (uint)NR <= NO_OF(php_params) );                                                    \
    string NAME;                                                                                \
    if( php_param_count >= NR ) {                                                               \
        convert_to_string( *php_params[NR-1] );                                                 \
        NAME.assign( (*php_params[NR-1])->value.str.val, (*php_params[NR-1])->value.str.len );  \
    }

//-------------------------------------------------------------------------------GET_PHP_PARAM_LONG

#define GET_PHP_PARAM_LONG(NR,NAME)                                                             \
    assert( (uint)NR <= NO_OF(php_params) );                                                    \
    long NAME = 0;                                                                              \
    if( php_param_count >= NR ) {                                                               \
        if( (*php_params[NR-1])->type != IS_LONG )  throw_xc( "SOS-PHP-103", #NAME, "Long" );   \
        NAME = (*php_params[NR-1])->value.lval;                                                 \
    }

//----------------------------------------------------------------------------GET_PHP_PARAM_SESSION

#define GET_PHP_PARAM_SESSION(NR)                                                               \
    assert( (uint)NR <= NO_OF(php_params) );                                                    \
    GET_PHP_PARAM_LONG( NR, session_nr )                                                        \
    Session* session = (Session*)sessions.by_index( session_nr );

//----------------------------------------------------------------------------GET_PHP_PARAM_VARIANT
/*
#define GET_PHP_PARAM_VARIANT(NR,NAME)                                                          \
    Variant NAME##_vt;                                                                          \
                                                                                                \
    if( ZEND_NUM_ARGS() >= NR ) {                                                               \
        pval_to_variant( *php_params[NR-1], &NAME##_vt );                                       \
    }
*/
//-------------------------------------------------------------------------------GET_PHP_PARAM_FILE

#define GET_PHP_PARAM_FILE(NR,NAME)                                                             \
    GET_PHP_PARAM_LONG( NR, NAME##_nr );                                                        \
    File* file = (File*)thread_data->_current_session->_files.by_index( NAME##_nr );

//-----------------------------------------------------------------------------GET_PHP_PARAM_RECORD

#define GET_PHP_PARAM_RECORD(NR,NAME)                                                           \
    GET_PHP_PARAM_LONG( NR, NAME##_nr );                                                        \
    Record* NAME = (Record*)thread_data->_current_session->_records.by_index( record_nr );

//--------------------------------------------------------------------------------------RETURN_STR

#define RETURN_STR(STRING)                                                                      \
{                                                                                               \
    string _result_ = STRING;                                                                   \
    RETURN_STRINGL( (char*)_result_.c_str(), _result_.length(), true );                         \
}

//----------------------------------------------------------------------------------Register::close

void Register::close()
{
    for( int i = _array.size() - 1; i >= 0; i-- )  
    {
        if( _array[i] )
        {
            close_object(i);
        }
    }
}

//---------------------------------------------------------------------------Register::close_object

void Register::close_object( int index )
{
    LOG( "hostPHP: " << _array[index]->obj_name() << ' ' << index <<  " wird freigegeben.\n" );

    by_index(index); 


    {
        Mutex_guard guard ( &semaphore );

        _array[index] = NULL;           // ~Any_file()
    }
}

//-----------------------------------------------------------------------------Register::free_index

int Register::free_index()
{
    vector< Sos_ptr<Registered> >::const_iterator it;

    for( it = _array.begin() + 1; it != _array.end(); it++ )  if( *it == NULL )  return it - _array.begin();

    int result = it - _array.begin();
    _array.push_back( NULL );
    return result;
}

//------------------------------------------------------------------------------------Register::add

int Register::add( const Sos_ptr<Registered>& object )
{
    int index = free_index();

    _array[index] = object;
    object->_index = index;
    return index;
}

//-------------------------------------------------------------------------------Register::by_index

Registered* Register::by_index( int index )
{
    if( index > 0  &&  (uint)index < _array.size() )
    {
        Registered* object = _array[ index ];
        if( object )  return object;
    }

    throw_xc( "SOS-PHP-101", _name.c_str(), index );
    return NULL;
}

//------------------------------------------------------------------------------------file_by_index

File* file_by_index( int file_nr )
{
    return (File*)thread_data->_current_session->_files.by_index( file_nr );
}

//------------------------------------------------------------------------------------file_by_index

File* file_by_index( zval* file_nr )
{
    return file_by_index( file_nr->value.lval );
}

//----------------------------------------------------------------------------------record_by_index

Record* record_by_index( zval* record_nr )
{
    return (Record*)thread_data->_current_session->_records.by_index( record_nr );
}

//--------------------------------------------------------------------------------------------begin

static Hostphp_thread_data* begin()
{
    //if( !SOS_LICENCE( licence_hostphp ) )  throw_xc( "SOS-1000", "hostPHP" );

    Hostphp_thread_data* t = thread_data.get();

    delete t->_last_xc;
    t->_last_xc = NULL;

    return t;
}

//---------------------------------------------------------------------------------exception_to_php

void exception_to_php( const exception& x )
{
    Hostphp_thread_data* t = thread_data.get();

    if( t->_last_xc )  delete t->_last_xc;
    t->_last_xc = new Xc( x );

    LOG( "exception_to_php error_mode=" << t->_error_mode << ", " << x.what() << "\n" );

    if( t->_error_mode ) {
        string what = x.what();
        zend_error( t->_error_mode, c_str(what) );
    }
}

//----------------------------------------------------------------------------------pval_as_record

static Sos_ptr<Record> pval_as_record( Record_type* type, zval* php_value )
{
    // Konvertiert einen PHP-Wert nach Record in den angegebenen Typ.
    // IS_LONG: Wird als Index in dynobj_array interpretiert, also als Record
    // Sonst: Wird als Text (Byte-Folge) interpretiert.

    Sos_ptr<Record> record;

  //if( type ) 
    {
        if( php_value->type == IS_LONG )     // Index in dynobj_array
        {
            record = record_by_index( php_value );
            if( record->_type  &&  type  &&  record->_type != type )  throw_xc( "SOS-1367", record->_type, type );
        } 
        else 
        {
            record = SOS_NEW( Record( thread_data->_current_session, type ) );
            record->assign( php_value );
        }
    }
/*
    else
    {
        record = SOS_NEW( Record( type ) );

        convert_to_string( php_value );
        record->_record.assign( php_value->value.str.val );
        Sos_ptr<Text_type> t = SOS_NEW( Text_type( record->_record.length() ) );
        t->_rtrim = false;
        record->_type = +t;
    }
*/

    return record;
}

//--------------------------------------------------------------------------------pval_to_dynobj

static void pval_to_dynobj( zval* php_value, Dyn_obj* dyn_obj )
{
    switch( php_value->type ) 
    {
        case IS_BOOL:
        {
            bool true_value  = true;
            bool false_value = false;
            dyn_obj->assign( &bool_type, php_value->value.lval? &true_value : &false_value );  
            break;
        }

        case IS_LONG:
        {
            dyn_obj->assign( &long_type, &php_value->value.lval );  
            break;
        }

        case IS_DOUBLE: 
        {
            dyn_obj->assign( &double_type, &php_value->value.dval );  
            break;
        }

        default: 
        {
            convert_to_string( php_value );
            *dyn_obj = php_value->value.str.val;
        }
    }
}

//-------------------------------------------------------------------------hostware_copy_file

extern "C" EXPORT PHP_FUNCTION( hostware_copy_file )
{
    Mutex_guard guard ( &semaphore );

    try {
        begin();

        LOGI( "hostware_copy_file()\n" );

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_STRING( 1, source_filename );
        GET_PHP_PARAM_STRING( 2, dest_filename );

        copy_file( source_filename, dest_filename );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//------------------------------------------------------------------------hostware_remove_file

extern "C" EXPORT PHP_FUNCTION( hostware_remove_file )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_remove_file()\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_STRING( 1, filename );

        remove_file( filename );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//-------------------------------------------------------------------------hostware_rename_file

extern "C" EXPORT PHP_FUNCTION( hostware_rename_file )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_rename_file()\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_STRING( 1, old_filename );
        GET_PHP_PARAM_STRING( 2, new_filename );

        rename_file( old_filename, new_filename );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//-----------------------------------------------------------------------hostware_file_as_string

extern "C" EXPORT PHP_FUNCTION( hostware_file_as_string )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_file_as_string()\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_STRING( 1, filename );

        string result = file_as_string( filename );

        RETURN_STR( result );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//--------------------------------------------------------------------------prepare_and_bind

static void prepare_and_bind( MY_TSRMLS_PARAM, int ht, Any_file* file )
{
    GET_PHP_PARAMS(1,2);
    GET_PHP_PARAM_STRING( 1, filename );

    file->prepare( "-in -seq " + filename, Any_file::Open_mode(0) );

    if( ZEND_NUM_ARGS() == 2 )
    {
        GET_PHP_PARAM_ZVAL  ( 2, zend_array );

/*
    const int params_base = 1;
    const int max_params = 10;

    GET_PHP_PARAMS( params_base, params_base+max_params );

    GET_PHP_PARAM_STRING( 1, filename );

    file->prepare( "-in -seq " + filename, Any_file::Open_mode(0) );

    if( ZEND_NUM_ARGS() == 2  &&  (*php_params[params_base])->type == IS_ARRAY )
    {
        GET_PHP_PARAM_ZVAL( 2, zend_array );
*/
        zval** current    = NULL;

        HashTable* zend_hash = HASH_OF( zend_array );
        int i = 0;

        for( zend_hash_internal_pointer_reset( zend_hash );
             zend_hash_get_current_data( zend_hash, (void**)&current ) == SUCCESS;
             zend_hash_move_forward( zend_hash ) )
        {
            SEPARATE_ZVAL( current );
            Dyn_obj dyn_obj;
            pval_to_dynobj( *current, &dyn_obj );
            file->set_parameter( 1+i, dyn_obj );
            i++;
        }
    }
/*  else
    {
        int n = ZEND_NUM_ARGS() - 1;

        for( int i = 0; i < n; i++ ) 
        {
            Dyn_obj dyn_obj;
            pval_to_dynobj( *php_params[params_base+i], &dyn_obj );
            file->set_parameter( 1+i, dyn_obj );
        }
    }
*/
}

//--------------------------------------------------------------------------hostware_get_single_

extern "C" EXPORT PHP_FUNCTION( hostware_get_single_ )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_file_get_single\n" );
        begin();

        Any_file        file;
        prepare_and_bind( MY_TSRMLS, ht, &file );

        file.open();

        Sos_ptr<Record> record = SOS_NEW( Record(thread_data->_current_session) );

        try {
            file.get( &record->_record );
            record->_type = +file.spec()._field_type_ptr;
            record->finish();
        }
        catch( const Eof_error& ) {}

        file.close();

        RETURN_LONG( record->index() ); 
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//--------------------------------------------------------------------------hostware_get_array_

extern "C" EXPORT PHP_FUNCTION( hostware_get_array_ )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_file_get_array\n" );
        begin();

        Any_file file;

        {
            Mutex_guard guard ( &semaphore );
         
            if( !thread_data->_current_session )  throw_xc( "SOS-PHP-104" );
            prepare_and_bind( MY_TSRMLS, ht, &file );
            file.open();
        }

        if( array_init(return_value) == FAILURE )  throw_xc( "SOS-PHP-array_init" );

        try {
            while(1)
            {
                Sos_ptr<Record> record = SOS_NEW( Record(thread_data->_current_session) );

                {
                    Mutex_guard guard ( &semaphore );
                    file.get( &record->_record );
                }

                record->_type = +file.spec()._field_type_ptr;
                record->finish();

                add_next_index_long( return_value, record->index() );
            }
        }
        catch( const Eof_error& ) {}

        {
            Mutex_guard guard ( &semaphore );
            file.close();
        }
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//-----------------------------------------------------------------------hostware_execute_direct

extern "C" EXPORT PHP_FUNCTION( hostware_execute_direct )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_file_execute_direct\n" );
        begin();

        const int params_base = 1;
        const int max_params = 10;

        GET_PHP_PARAMS( params_base, params_base+max_params );

        GET_PHP_PARAM_STRING( 1, filename );

        Any_file file;

        file.prepare( "-in -seq " + filename, Any_file::Open_mode(0) );

        int n = ZEND_NUM_ARGS() - 1;

        for( int i = 0; i < n; i++ ) 
        {
            Dyn_obj dyn_obj;
            pval_to_dynobj( *php_params[params_base+i], &dyn_obj );
            file.set_parameter( 1+i, dyn_obj );
        }

        file.execute();
        file.close();
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//---------------------------------------------------------------------------------hostware_as_date

extern "C" EXPORT PHP_FUNCTION( hostware_as_date )
{
    Mutex_guard guard ( &semaphore );

    try {
        begin();

        //LOG( "current_session=" << (void*)thread_data->_current_session << '\n' );


        GET_PHP_PARAMS(1,2);
        GET_PHP_PARAM_AS_STRING( 1, date );
        GET_PHP_PARAM_AS_STRING( 2, format );

        if( format == "" )  format = std_date_format_iso;

        Sos_optional_date_time datetime;

        datetime.read_text( date, c_str(format) );
        if( datetime.time_is_zero() )  datetime.date_only( true );
        string result = datetime.formatted();

        RETURN_STR( result );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//---------------------------------------------------------------------------hostware_date_as_string

extern "C" EXPORT PHP_FUNCTION( hostware_date_as_string )
{
    Mutex_guard guard ( &semaphore );

    try {
        begin();

        GET_PHP_PARAMS(1,2);
        GET_PHP_PARAM_STRING( 1, date   );
        GET_PHP_PARAM_STRING( 2, format );

        if( format == "" )  format = std_date_format_iso;


        Sos_optional_date_time  datetime;

        datetime.read_text( date );
        if( datetime.time_is_zero() )  datetime.date_only( true );
        string result = datetime.formatted( format );

        RETURN_STR( result );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//---------------------------------------------------------------------------hostware_as_xml_

extern "C" EXPORT PHP_FUNCTION( hostware_as_xml_ )
{
    Mutex_guard guard ( &semaphore );

    try {
        begin();

        GET_PHP_PARAMS(1,2);
        GET_PHP_PARAM_STRING( 1, value );
        GET_PHP_PARAM_STRING( 2, options );

        string result;
/*
        if( php_value->type == IS_LONG )    // Dynobj?
        {
            Record* record = record_by_index( php_value->value.lval );
            result = record->as_xml();
        }
        else
*/
        {
            result = sos::as_xml( value, options );
        }

        RETURN_STR( result )
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//---------------------------------------------------------------------------hostware_from_xml

extern "C" EXPORT PHP_FUNCTION( hostware_from_xml )
{
    Mutex_guard guard ( &semaphore );

    try {
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_STRING( 1, xml_text );

        RETURN_STR( xml_as_string( xml_text ) )
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//---------------------------------------------------------------------------hostware_sql_equal

extern "C" EXPORT PHP_FUNCTION( hostware_sql_equal )
{
    Mutex_guard guard ( &semaphore );

    try {
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_STRING ( 1, field_name );
        GET_PHP_PARAM_ZVAL   ( 2, value_zval );

        string expr = field_name;

        if( value_zval->type == IS_NULL )
        {
            expr += " IS NULL";
        }
        else
        {
            GET_PHP_PARAM_AS_STRING( 2, value );
            expr += "=" + quoted_string( value, '\'', '\'' );
        }

        RETURN_STR( expr );

    }
    catch( const exception& x )  { exception_to_php(x); }
}

//---------------------------------------------------------------------------hostware_sql_quoted

extern "C" EXPORT PHP_FUNCTION( hostware_sql_quoted )
{
    Mutex_guard guard ( &semaphore );

    try {
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_ZVAL( 1, value_zval );

        switch( value_zval->type ) 
        {
            case IS_NULL:
                RETURN_STRING( "NULL", true );
                break;

            default:      
            {
                GET_PHP_PARAM_AS_STRING( 2, value );
                Sos_string result = quoted_string( value, '\'', '\'' );
                RETURN_STR( result )
            }
        }
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//---------------------------------------------------------------------------hostware_file_exists

extern "C" EXPORT PHP_FUNCTION( hostware_file_exists )
{
    Mutex_guard guard ( &semaphore );

    try {
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_STRING( 1, filename );

        if( sos::file_exists( filename ) ) { RETVAL_TRUE; }
                                      else { RETVAL_FALSE; }
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//---------------------------------------------------------------------------hostware_make_path

extern "C" EXPORT PHP_FUNCTION( hostware_make_path )
{
    Mutex_guard guard ( &semaphore );

    try {
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_STRING( 1, filename );

        sos::make_path( filename );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//----------------------------------------------------------------------hostware_set_error_mode

extern "C" EXPORT PHP_FUNCTION( hostware_set_error_mode )
{
    Mutex_guard guard ( &semaphore );

    try {
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_LONG( 1, mode );

        thread_data->_error_mode = mode;
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//-------------------------------------------------------------------------------hostware_error

extern "C" EXPORT PHP_FUNCTION( hostware_error )
{
    Mutex_guard guard ( &semaphore );

    //begin() lscht last_xc
    if( ARG_COUNT(ht) != 0 )  WRONG_PARAM_COUNT;

    if( thread_data->_last_xc ) { RETVAL_TRUE; }
                           else { RETVAL_FALSE; }
}

//----------------------------------------------------------------------hostware_exception_name

extern "C" EXPORT PHP_FUNCTION( hostware_exception_name )
{
    Mutex_guard guard ( &semaphore );

    //begin() lscht last_xc

    if( ZEND_NUM_ARGS() != 0 )  WRONG_PARAM_COUNT;

    if( thread_data->_last_xc )  { RETVAL_STRING( (char*)(thread_data->_last_xc)->name(), true ); }
                           else  { RETVAL_STRING( "", true ); }
}

//--------------------------------------------------------------------------hostware_error_code

extern "C" EXPORT PHP_FUNCTION( hostware_error_code )
{
    Mutex_guard guard ( &semaphore );

    //begin() lscht last_xc

    if( ZEND_NUM_ARGS() != 0 )  WRONG_PARAM_COUNT;

    if( thread_data->_last_xc )  { RETVAL_STRING( (char*)(thread_data->_last_xc)->code(), true ); }
                           else  { RETVAL_STRING( "", true ); }
}

//--------------------------------------------------------------------------hostware_error_text

extern "C" EXPORT PHP_FUNCTION( hostware_error_text )
{
    Mutex_guard guard ( &semaphore );

    //begin() lscht last_xc

    if( ZEND_NUM_ARGS() != 0 )  WRONG_PARAM_COUNT;

    if( thread_data->_last_xc ) 
    { 
        string text = (thread_data->_last_xc)->what();
        RETVAL_STRING( (char*)text.c_str(), true ); 
    }
    else 
    { 
        RETVAL_STRING( "", true ); 
    }
}

//--------------------------------------------------------------------------hostware_file__new

extern "C" EXPORT PHP_FUNCTION( hostware_file__new )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_file__new()\n" );
        begin();

        if( ZEND_NUM_ARGS() != 0 )  WRONG_PARAM_COUNT;

        if( !thread_data->_current_session )  throw_xc( "SOS-PHP-104" );

        Sos_ptr<File> file = SOS_NEW( File( thread_data->_current_session ) );
        uint file_nr = thread_data->_current_session->_files.add( +file );

        RETURN_LONG( file_nr );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//-----------------------------------------------------------------------hostware_file__delete

extern "C" EXPORT PHP_FUNCTION( hostware_file__delete )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_file__delete()\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_FILE( 1, file );

        thread_data->_current_session->_files.close_object( file_nr );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//------------------------------------------------------------------------hostware_file_prepare

extern "C" EXPORT PHP_FUNCTION( hostware_file_prepare )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_file_prepare\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_STRING( 2, filename );

        file->_any_file.prepare( file->_filename_prefix + filename, (Any_file::Open_mode)0 );
        
        file->_type      = +file->_any_file.spec()._field_type_ptr;
        file->_key_descr = +file->_any_file.spec()._key_specs._key_spec._field_descr_ptr;
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//------------------------------------------------------------------hostware_file_set_parameter

extern "C" EXPORT PHP_FUNCTION( hostware_file_set_parameter )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_file_set_parameter\n" );
        begin();

        GET_PHP_PARAMS(3,3);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_LONG  ( 2, param_nr );
        GET_PHP_PARAM_ZVAL  ( 3, param );

        if( param_nr >= (int)file->_param_values.size() )  file->_param_values.resize( param_nr+1 );
        pval_to_dynobj( param, &file->_param_values[param_nr] );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//---------------------------------------------------------------------------hostware_file_execute

extern "C" EXPORT PHP_FUNCTION( hostware_file_execute )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_file_execute\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_FILE  ( 1, file );

        file->_any_file.clear_parameters();

        for( int i = 1; i < file->_param_values.size(); i++ )
        {
            file->_any_file.set_parameter( i, file->_param_values[i] );
        }

        file->_any_file.execute();
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//-------------------------------------------------------------------------------hostware_file_open

extern "C" EXPORT PHP_FUNCTION( hostware_file_open )
{
    Mutex_guard guard ( &semaphore );

    try {
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_STRING( 2, filename );

        LOGI( "hostware_file_open()\n" );

        if( filename[0] == '\0' )  file->_any_file.open();
                             else  file->_any_file.open( filename, (Any_file::Open_mode)0 );

        file->_type = +file->_any_file.spec()._field_type_ptr;
        file->_key_descr = +file->_any_file.spec()._key_specs._key_spec._field_descr_ptr;
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//-----------------------------------------------------------------------hostware_file_close

extern "C" EXPORT PHP_FUNCTION( hostware_file_close )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_file_close()\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_FILE  ( 1, file );

        file->_any_file.close();
        RENEW( file->_any_file, Any_file );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//-----------------------------------------------------------hostware_file_close_cursor

extern "C" EXPORT PHP_FUNCTION( hostware_file_close_cursor )
{
    Mutex_guard guard ( &semaphore );

    try 
    {
        LOGI( "hostware_file_close_cursor\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_FILE  ( 1, file );

        file->_any_file.close( sos::close_cursor );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//-------------------------------------------------------------------hostware_file_opened

extern "C" EXPORT PHP_FUNCTION( hostware_file_opened )
{
    Mutex_guard guard ( &semaphore );

    try {
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_FILE  ( 1, file );

        if( file->_any_file.opened() )  { RETVAL_TRUE; }
                                  else  { RETVAL_FALSE; }
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//----------------------------------------------------------------hostware_file_eof

extern "C" EXPORT PHP_FUNCTION( hostware_file_eof )
{
    Mutex_guard guard ( &semaphore );

    try 
    {
        //LOGI( "hostware_file_eof\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_FILE  ( 1, file );

        if( file->_any_file.eof() )  { RETVAL_TRUE; }
                               else  { RETURN_FALSE; }
    }   
    catch( const exception& x )  { exception_to_php(x); }
}                                                 

//------------------------------------------------------------------hostware_file_create_record

extern "C" EXPORT PHP_FUNCTION( hostware_file_create_record )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_file_create_record\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_FILE  ( 1, file );

        if( !file->_type )  throw_xc( "SOS-1193" );

        Sos_ptr<Record> record = SOS_NEW( Record( thread_data->_current_session, file->_type, file ) );
        record->construct();
        RETURN_LONG( record->index() );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//---------------------------------------------------------------------hostware_file_create_key

extern "C" EXPORT PHP_FUNCTION( hostware_file_create_key )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_file_create_key\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_FILE  ( 1, file );

        if( !file->_key_descr )  throw_xc( "SOS-1214", "hostWare" );

        Sos_ptr<Record> k = SOS_NEW( Record( thread_data->_current_session, SOS_CAST( Record_type, file->_key_descr->type_ptr() ), file ) );
        k->construct();
        RETURN_LONG( k->index() );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//----------------------------------------------------------------------hostware_file_get_line

extern "C" EXPORT PHP_FUNCTION( hostware_file_get_line )
{
    Mutex_guard guard ( &semaphore );

    try {
        //LOGI( "hostware_file_get_line\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_FILE  ( 1, file );

        Dynamic_area line;

        file->_any_file.get( &line );

        RETURN_STRINGL( line.char_ptr(), line.length(), true );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//---------------------------------------------------------------------------hostware_file_get

extern "C" EXPORT PHP_FUNCTION( hostware_file_get )
{
    Mutex_guard guard ( &semaphore );

    try {
        //LOGI( "hostware_file_get\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_FILE  ( 1, file );

        Sos_ptr<Record> record = SOS_NEW( Record( thread_data->_current_session, file->_type, file ) );

        file->_any_file.get( &record->_record );

        record->finish();
        RETURN_LONG( record->index() );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//-------------------------------------------------------------------------hostware_file_rewind

extern "C" EXPORT PHP_FUNCTION( hostware_file_rewind )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_file_rewind\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_FILE  ( 1, file );

        file->_any_file.rewind();
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//-------------------------------------------------------------------------hostware_file_put

extern "C" EXPORT PHP_FUNCTION( hostware_file_put )
{
    Mutex_guard guard ( &semaphore );

    try {
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_ZVAL  ( 2, record_zval );

        Sos_ptr<Record> record = file->get_record_data( record_zval );

        file->_any_file.put( record->_record );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//--------------------------------------------------------------------hostware_file_put_line

extern "C" EXPORT PHP_FUNCTION( hostware_file_put_line )
{
    Mutex_guard guard ( &semaphore );

    try {
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_STRING( 2, line );

        file->_any_file.put( line );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//-----------------------------------------------------------------------hostware_file_set_key

extern "C" EXPORT PHP_FUNCTION( hostware_file_set_key )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_file_set_key\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_ZVAL  ( 2, key );

        Sos_ptr<Record> k = file->get_key_data( key );

        file->_any_file.set( k->_record );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//--------------------------------------------------------------------hostware_file_delete_key

extern "C" EXPORT PHP_FUNCTION( hostware_file_delete_key )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_file_delete_key\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_ZVAL  ( 2, key );

        Sos_ptr<Record> k = file->get_key_data( key );
        
        file->_any_file.del( k->_record );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//-----------------------------------------------------------------------hostware_file_get_key

extern "C" EXPORT PHP_FUNCTION( hostware_file_get_key )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_file_get_key\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_ZVAL  ( 2, key );

        Sos_ptr<Record> record = SOS_NEW( Record( thread_data->_current_session, file->_type, file ) );
        Sos_ptr<Record> k = file->get_key_data( key );

        file->_any_file.get_key( &record->_record, k->_record );

        record->finish();
        RETURN_LONG( record->index() );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//-----------------------------------------------------------------------hostware_file_insert

extern "C" EXPORT PHP_FUNCTION( hostware_file_insert )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_file_insert\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_ZVAL  ( 2, record_zval );
        
        Sos_ptr<Record> record = file->get_record_data( record_zval );

        file->_any_file.insert( record->_record );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//------------------------------------------------------------------------hostware_file_update

extern "C" EXPORT PHP_FUNCTION( hostware_file_update )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_file_update\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_ZVAL  ( 2, record_zval );

        Sos_ptr<Record> record = file->get_record_data( record_zval );

        file->_any_file.update( record->_record );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//-----------------------------------------------------------------hostware_file_update_direct
                                                                      
extern "C" EXPORT PHP_FUNCTION( hostware_file_update_direct )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_file_update_direct\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_ZVAL  ( 2, record_zval );

        Sos_ptr<Record> record = file->get_record_data( record_zval );

        file->_any_file.update_direct( record->_record );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//-------------------------------------------------------------------------hostware_file_store

extern "C" EXPORT PHP_FUNCTION( hostware_file_store )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_file_store\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_ZVAL  ( 2, record_zval );
        
        Sos_ptr<Record> record = file->get_record_data( record_zval );

        file->_any_file.store( record->_record );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//----------------------------------------------------------------hostware_file_set_date_format

extern "C" EXPORT PHP_FUNCTION( hostware_file_set_date_format )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_file_put_date_format\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_STRING( 2, format );

        file->_text_format.date( format.c_str() );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//------------------------------------------------------------hostware_file_set_date_time_format

extern "C" EXPORT PHP_FUNCTION( hostware_file_set_date_time_format )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_file_put_date_time_format\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_STRING( 2, format );

        file->_text_format.date_time( format.c_str() );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//-------------------------------------------------------------hostware_file_set_decimal_symbol

extern "C" EXPORT PHP_FUNCTION( hostware_file_set_decimal_symbol )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_file_set_decimal_symbol\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_STRING( 2, symbol );
        
        file->_text_format.decimal_symbol( symbol.c_str()[0] );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//---------------------------------------------------------------------hostware_file_field_name

extern "C" EXPORT PHP_FUNCTION( hostware_file_field_name )
{
    Mutex_guard guard ( &semaphore );

    try {
        //LOGI( "hostware_file_field_name\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_LONG  ( 2, field_nr );

        Field_descr* field_descr = file->_type->field_descr_ptr( field_nr );

        RETURN_STR( field_descr->name() );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//--------------------------------------------------------------------hostware_file_field_count

extern "C" EXPORT PHP_FUNCTION( hostware_file_field_count )
{
    Mutex_guard guard ( &semaphore );

    try {
        //LOGI( "hostware_file_field_count\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_FILE  ( 1, file );

        if( !file->_type )  RETURN_LONG( 0 );

        RETURN_LONG( file->_type->field_count() );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//---------------------------------------------------------hostware_file_set_write_empty_as_null

extern "C" EXPORT PHP_FUNCTION( hostware_file_set_write_empty_as_null )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_file_set_write_empty_as_null\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_LONG  ( 2, value );

        file->_write_empty_as_null = value != 0;
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//---------------------------------------------------------------------hostware_file_debug_info
/*
extern "C" EXPORT PHP_FUNCTION( hostware_file_debug_info )
{
    try
    {
        Mutex_guard guard ( &semaphore );

        LOGI( "hostware_file_debug_info\n" );
        begin();

        if( !_any_file.opened() ) 
        {
            *text = SysAllocString( L"CLOSED" );
        } 
        else 
        {
            *text = SysAllocString_string( _any_file.name() );
        }
    }
    catch( const exception& x ) 
    { 
        Dynamic_area buffer;
        x.get_text( &buffer );
        *text = SysAllocStringLen_char( buffer.char_ptr(), buffer.length() );
    }

    return hr;
}
*/
//---------------------------------------------------------------------------File::get_record_data

Sos_ptr<Record> File::get_record_data( zval* php_record )
{
    //if( !_type )  throw_xc( "SOS-1193" );

    return pval_as_record( _type, php_record );
}

//-------------------------------------------------------------------------------File::get_key_data

Sos_ptr<Record> File::get_key_data( zval* php_key )
{
    return pval_as_record( _key_descr && _key_descr->type_ptr()? SOS_CAST( Record_type, _key_descr->type_ptr() ) 
                                                               : NULL, 
                           php_key );
}

//-----------------------------------------------------------------------------------Record::Record

Record::Record( Session* session, Record_type* type, File* file )
:
    _session(session),
    _type ( type )
{
    if( !SOS_LICENCE( licence_hostphp ) )  throw_xc( "SOS-1000", "hostPHP" );

    //?jz 1.6.98  if( !_type )  _type = Record_type::create();

    // Parameter file nicht merken, wird evtl. vor diesem Objekt geschlossen!
    if( file ) {
        _text_format = file->_text_format;
        _write_empty_as_null = file->_write_empty_as_null;
    }

    if( _type )  _record.allocate_min( _type->field_size() );

    thread_data->_current_session->_records.add( this );
}

//-----------------------------------------------------------------------------------Record::Record

Record::Record( const Record& record )
{
    *this = record;
    thread_data->_current_session->_records.add( this );
}

//----------------------------------------------------------------------------------Record::~Record

Record::~Record()
{
}

//-------------------------------------------------------------------------------Record::operator =

Record& Record::operator = ( const Record& record )
{
    _type           = record._type;
    _record         = record._record;
    _text_format    = record._text_format;

    if( _type )  _record.allocate_min( _type->field_size() );

    return *this;
}

//--------------------------------------------------------------------------------Record::_obj_name

string Record::_obj_name() const
{ 
    string result = "Record";

    if( _type && _type->obj_is_type(tc_Record_type) )  result += '(', result += ((Record_type*)+_type)->name(), result += ')';

    return result;
}

//--------------------------------------------------------------------------hostware_dynobj__delete

extern "C" EXPORT PHP_FUNCTION( hostware_dynobj__delete )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_dynobj__delete()\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_RECORD( 1, record );

        thread_data->_current_session->_records.close_object( record_nr );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//--------------------------------------------------------------------------hostware_dynobj_clone

extern "C" EXPORT PHP_FUNCTION( hostware_dynobj_clone )
{
    Mutex_guard guard ( &semaphore );

    try {
      //LOGI( "Record::clone\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_RECORD( 1, record );

        Sos_ptr<Record> clone = SOS_NEW( Record( *record ) );
        
        RETURN_LONG( clone->index() );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//-------------------------------------------------------hostware_dynobj_set_write_empty_as_null

extern "C" EXPORT PHP_FUNCTION( hostware_dynobj_set_write_empty_as_null )
{
    Mutex_guard guard ( &semaphore );

    try {
      //LOGI( "hostware_dynobj_set_write_empty_as_null\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_RECORD( 1, record );
        GET_PHP_PARAM_LONG  ( 2, value );

        record->_write_empty_as_null = value != 0;
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//---------------------------------------------------------------------------Record::field

Field_descr* Record::field( zval* name )
{
    if( name->type == IS_LONG ) 
    {
        if( !_type ) {
            string nam = as_string(name->value.lval);
            throw_xc( "SOS-1179", c_str(nam), "NULL-Dynobj" );
        }

        return _type->field_descr_ptr( name->value.lval );
    }
    else 
    {
        convert_to_string( name );
        if( !_type )  throw_xc( "SOS-1179", name->value.str.val, "NULL-Dynobj" );
        return SOS_CAST( Record_type, _type ) -> field_descr_ptr( name->value.str.val );
    }
}

//------------------------------------------------------------------------hostware_dynobj_assign

void Record::assign( zval* php_value )
{
    if( _type )
    {
        _record.allocate_min( _type->field_size() );
/*
        if( V_VT( &variant ) == VT_ARRAY ) 
        {
            long        lower_bound;
            long        upper_bound;
            int         i;
            int         n;
            VARIANT*    array = NULL;

            hr = SafeArrayGetLBound( V_ARRAY( &variant ), 1, &lower_bound );
            if( FAILED( hr ) )  throw_ole( hr, "SafeArrayGetLBound" );

            hr = SafeArrayGetUBound( V_ARRAY( &variant ), 1, &upper_bound );
            if( FAILED( hr ) )  throw_ole( hr, "SafeArrayGetUBound" );

            n = upper_bound - lower_bound + 1;
            if( n > _type->field_count() )  { Sos_string n_str = as_string( n ); throw_xc( "SOS-1375", _type, c_str(n_str) ); }

            hr = SafeArrayAccessData( V_ARRAY( &variant ), (void __huge**)&array );
            if( FAILED( hr ) )  throw_ole( hr, "SafeArrayAccessData" );

            for( i = 0; i < _type->field_count(); i++ ) {
                if( i >= n )  break;
                variant_to_char( array[ i ], &_value_buffer );
                _type->read_text( _record.byte_ptr(), _value_buffer.char_ptr() );
            }

            // Nicht gesetzte Felder lschen:
            for(; i < _type->field_count(); i++ )  _type->clear( _record.byte_ptr() );
        } 
        else 
*/
        {
            convert_to_string( php_value );
            _type->read_text( _record.byte_ptr(), php_value->value.str.val );
            _record.length( _type->field_size() );
        }
    }
    else
    {
        convert_to_string( php_value );
        _record.assign( php_value->value.str.val );
        Sos_ptr<Text_type> t = SOS_NEW( Text_type( _record.length() ) );
        t->_rtrim = false;
        _type = +t;
    }
}

//-------------------------------------------------------------------------Record::as_xml

string Record::as_xml()
{
    if( _type ) 
    {
        if( !_type->obj_is_type( tc_Record_type ) )   throw_xc( "SOS-1193" );

        return sos::as_xml( (Record_type*)+_type, _record );
    }
    else
    {
        return sos::as_xml( _record.char_ptr() );
    }
}

//----------------------------------------------------------------------------hostware_dynobj_empty

extern "C" EXPORT PHP_FUNCTION( hostware_dynobj_empty )
{
    Mutex_guard guard ( &semaphore );

    try {
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_RECORD( 1, record );

        if( record->_type ) { RETVAL_FALSE; }
                       else { RETVAL_TRUE; }
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//----------------------------------------------------------------------hostware_dynobj_field_count

extern "C" EXPORT PHP_FUNCTION( hostware_dynobj_field_count )
{
    Mutex_guard guard ( &semaphore );

    try {
        //LOGI( "hostware_dynobj_field_count\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_RECORD( 1, record );


        RETURN_LONG( record->_type->field_count() );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//-----------------------------------------------------------------------hostware_dynobj_field_name

extern "C" EXPORT PHP_FUNCTION( hostware_dynobj_field_name )
{
    Mutex_guard guard ( &semaphore );

    try {
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_RECORD( 1, record );
        GET_PHP_PARAM_LONG  ( 2, field_nr );

        string result = SOS_CAST( Record_type, record->_type ) -> field_descr( field_nr ).name();
        RETURN_STR( result )
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//----------------------------------------------------------------------hostware_dynobj_field_index

extern "C" EXPORT PHP_FUNCTION( hostware_dynobj_field_index )
{
    Mutex_guard guard ( &semaphore );

    try {
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_RECORD( 1, record );
        GET_PHP_PARAM_STRING( 2, name );

        RETURN_LONG( SOS_CAST( Record_type, record->_type ) -> field_index( name.c_str() ) );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//---------------------------------------------------------------------------hostware_dynobj_field

extern "C" EXPORT PHP_FUNCTION( hostware_dynobj_field )
{
    Mutex_guard guard ( &semaphore );

    try {
        Hostphp_thread_data* t = begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_RECORD( 1, record );
        GET_PHP_PARAM_ZVAL  ( 2, name );

        Field_descr* field = record->field( name );

        if( field->null( record->_record.byte_ptr() ) ) 
        {
            RETVAL_NULL();
        } 
        else 
        {
            field->write_text( record->_record, &t->_buffer, record->_text_format );
            RETURN_STRINGL( t->_buffer.char_ptr(), t->_buffer.length(), true );
        }
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//-----------------------------------------------------------------------hostware_dynobj_set_field

extern "C" EXPORT PHP_FUNCTION( hostware_dynobj_set_field )
{
    Mutex_guard guard ( &semaphore );

    try {
        begin();

        GET_PHP_PARAMS(3,3);
        GET_PHP_PARAM_RECORD   ( 1, record );
        GET_PHP_PARAM_ZVAL     ( 2, name );
        GET_PHP_PARAM_AS_STRING( 3, value );
        
        Field_descr* field = record->field( name );

        field->read_text( &record->_record, value.c_str(), record->_text_format );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//-----------------------------------------------------------------------hostware_dynobj_add_field

extern "C" EXPORT PHP_FUNCTION( hostware_dynobj_add_field )
{
    Mutex_guard guard ( &semaphore );

    try {
        begin();

        GET_PHP_PARAMS(3,3);
        GET_PHP_PARAM_RECORD( 1, record );
        GET_PHP_PARAM_STRING( 2, name );
        GET_PHP_PARAM_STRING( 3, type_name );


        Sos_ptr<Field_type> type;

        LOGI( "hostware_dynobj_add_field(" << name << ',' << type_name << ")\n" );

        if( !record->_type )  record->_type = Record_type::create();
        if( record->_type->obj_ref_count() > 1 )  record->_type = copy_record_type( SOS_CAST( Record_type, record->_type ) );

        Field_descr* field = SOS_CAST( Record_type, record->_type ) -> add_field( type_name, name, true );

        record->_record.resize_min( record->_type->field_size() );
        record->_record.length( record->_type->field_size() );
        field->construct( record->_record.byte_ptr() );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//------------------------------------------------------------------------------hostware_dynobj_xml

extern "C" EXPORT PHP_FUNCTION( hostware_dynobj_xml )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_dynobj_xml()\n" );
        begin();

        GET_PHP_PARAMS(1,2);
        GET_PHP_PARAM_RECORD( 1, record );
        GET_PHP_PARAM_STRING( 2, options );

        RETURN_STR( record->as_xml() );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//----------------------------------------------------------------------------hostware_dynobj_set_xml

extern "C" EXPORT PHP_FUNCTION( hostware_dynobj_set_xml )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_dynobj_set_xml()\n" );
        begin();

        GET_PHP_PARAMS(3,3);
        GET_PHP_PARAM_RECORD( 1, record );
        GET_PHP_PARAM_STRING( 2, options );
        GET_PHP_PARAM_STRING( 3, xml );


        Xml_processor xml_processor;

        xml_processor.init_read( xml.c_str(), xml.length() );
        
        record->_record.allocate_min( record->_type->field_size() );
        record->_record.length( record->_type->field_size() );

        xml_processor.parse_record_fields( SOS_CAST( Record_type, record->_type ), record->_record.byte_ptr() );

        xml_processor.expect( Xml_processor::sym_eof );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//--------------------------------------------------------------------Record::construct

void Record::construct()
{
    _record.allocate_min( _type->field_size() );
    _record.length( _type->field_size() );
    _type->construct( _record.byte_ptr() );
}

//-----------------------------------------------------------------------Record::finish

void Record::finish()
{
    if( !_type ) 
    {
        _record += '\0';
        Sos_ptr<String0_type> t = SOS_NEW( String0_type( _record.length() - 1 ) );
        Sos_ptr<Record_type> r = SOS_NEW( Record_type );
        r->add_field( +t, "field", 0 );
        _type = +r;
    }

    int zu_kurz = _type->field_size() - _record.length();
    if( zu_kurz > 0 ) {
      //if( _record.size() < _type->field_size() )  throw_xc( "Record::finish" );  // FEHLER
        memset( _record.char_ptr() + _record.length(), 0, zu_kurz );
    }
}

//-------------------------------------------------------------------Record::_obj_print
/*
void Record::_obj_print( ostream* s ) const
{
    *s << "Record(";
    
    if( _type && _record.byte_ptr() ) {
        if( _type->obj_is_type( tc_Record_type ) )  *s << ((Record_type*)+_type)->name();
                                              else  *s << _type->info()->_name;
    } else {
        *s << "NULL";
    }

    *s << ')';
}
*/
//---------------------------------------------------------------------------hostware_variable__new
/*
extern "C" EXPORT PHP_FUNCTION( hostware_variable__new )
{
    try {
        Mutex_guard guard ( &semaphore );
        begin();

        zval* php_name   = NULL;

        if( ZEND_NUM_ARGS() != 1  ||  zend_get_parameters( ht,  1, &php_name ) == FAILURE )  WRONG_PARAM_COUNT;
        convert_to_string( php_name );

        Record* record     = record_by_index( php_dynobj );
        Field_descr*     field = record->field( php_name );

        field->read_text( &record->_record, php_value->value.str.val, record->_text_format );
    }
    catch( const exception& x )  { exception_to_php(x); }
}
*/
//----------------------------------------------------------------------hostware_variable_set_value
/*
extern "C" EXPORT PHP_FUNCTION( hostware_variable_set_value )
{
    try {
        Mutex_guard guard ( &semaphore );
        begin();

        zval* php_dynobj = NULL;
        zval* php_name   = NULL;
        zval* php_value  = NULL;

        if( ZEND_NUM_ARGS() != 3  ||  zend_get_parameters( ht,  3, &php_dynobj, &php_name, &php_value ) == FAILURE )  WRONG_PARAM_COUNT;
        convert_to_string( php_value );

        Record* record     = record_by_index( php_dynobj );
        Field_descr*     field = record->field( php_name );

        field->read_text( &record->_record, php_value->value.str.val, record->_text_format );
    }
    catch( const exception& x )  { exception_to_php(x); }
}
*/
//-----------------------------------------------------------------------hostware_session__new

extern "C" EXPORT PHP_FUNCTION( hostware_session__new )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_session__new()\n" );
        begin();

        if( ZEND_NUM_ARGS() != 0 )  WRONG_PARAM_COUNT;

        Sos_ptr<Session> session = SOS_NEW( Session );
        int session_nr = sessions.add( +session );

        thread_data->_current_session = session;

        RETURN_LONG( session_nr );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//--------------------------------------------------------------------hostware_session__delete

extern "C" EXPORT PHP_FUNCTION( hostware_session__delete )
{
    Mutex_guard guard ( &semaphore );

    try {
        LOGI( "hostware_session__delete()\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_SESSION( 1 );

        //LOG( "current_session=" << (void*)thread_data->_current_session << '\n' );
        sessions.close_object( session_nr );

        thread_data->_current_session = NULL;
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//-----------------------------------------------------------------------------hostware_set_session

extern "C" EXPORT PHP_FUNCTION( hostware_set_session )
{
    Mutex_guard guard ( &semaphore );

    try {
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_SESSION( 1 );

        thread_data->_current_session = session;
        //LOG( "current_session=" << (void*)thread_data->_current_session << '\n' );
    }
    catch( const exception& x )  { exception_to_php(x); }
}

//-------------------------------------------------------------------------------------------------

} //namespace php
} //namespace sos

//-------------------------------------------------------------------------------------------------

extern "C" {

using namespace sos::php;


function_entry php_hostware_functions[] =
{
    PHP_FE( hostware_copy_file           , NULL )
    PHP_FE( hostware_remove_file         , NULL )
    PHP_FE( hostware_rename_file         , NULL )
    PHP_FE( hostware_file_as_string      , NULL )
    PHP_FE( hostware_get_single_         , NULL )
    PHP_FE( hostware_execute_direct      , NULL )
    PHP_FE( hostware_as_date             , NULL )
    PHP_FE( hostware_date_as_string      , NULL )
    PHP_FE( hostware_get_array_          , NULL )
    PHP_FE( hostware_as_xml_             , NULL )
    PHP_FE( hostware_from_xml            , NULL )
    PHP_FE( hostware_sql_quoted          , NULL )
    PHP_FE( hostware_sql_equal           , NULL )
    PHP_FE( hostware_file_exists         , NULL )
    PHP_FE( hostware_make_path           , NULL )

    PHP_FE( hostware_set_error_mode      , NULL )
    PHP_FE( hostware_error               , NULL )
    PHP_FE( hostware_exception_name      , NULL )
    PHP_FE( hostware_error_code          , NULL )
    PHP_FE( hostware_error_text          , NULL )

    PHP_FE( hostware_file__new                  , NULL )
    PHP_FE( hostware_file__delete               , NULL )
    PHP_FE( hostware_file_prepare               , NULL )
    PHP_FE( hostware_file_open                  , NULL )
    PHP_FE( hostware_file_execute               , NULL )
    PHP_FE( hostware_file_create_record         , NULL )
    PHP_FE( hostware_file_create_key            , NULL )
    PHP_FE( hostware_file_close                 , NULL )
    PHP_FE( hostware_file_close_cursor          , NULL )
    PHP_FE( hostware_file_opened                , NULL )
    PHP_FE( hostware_file_eof                   , NULL )
    PHP_FE( hostware_file_get                   , NULL )
    PHP_FE( hostware_file_get_line              , NULL )
    PHP_FE( hostware_file_rewind                , NULL )
    PHP_FE( hostware_file_put                   , NULL )
    PHP_FE( hostware_file_put_line              , NULL )
    PHP_FE( hostware_file_set_key               , NULL )
    PHP_FE( hostware_file_delete_key            , NULL )
    PHP_FE( hostware_file_get_key               , NULL )
    PHP_FE( hostware_file_insert                , NULL )
    PHP_FE( hostware_file_store                 , NULL )
    PHP_FE( hostware_file_update                , NULL )
    PHP_FE( hostware_file_update_direct         , NULL )
    PHP_FE( hostware_file_set_parameter         , NULL )
    PHP_FE( hostware_file_set_date_format       , NULL )
    PHP_FE( hostware_file_set_date_time_format  , NULL )
    PHP_FE( hostware_file_set_decimal_symbol    , NULL )
    PHP_FE( hostware_file_field_name            , NULL )
    PHP_FE( hostware_file_field_count           , NULL )

    PHP_FE( hostware_dynobj__delete             , NULL )
    PHP_FE( hostware_dynobj_clone               , NULL )
    PHP_FE( hostware_dynobj_set_write_empty_as_null, NULL )
    PHP_FE( hostware_dynobj_empty               , NULL )
    PHP_FE( hostware_dynobj_field_name          , NULL )
    PHP_FE( hostware_dynobj_field_count         , NULL )
    PHP_FE( hostware_dynobj_field_index         , NULL )
    PHP_FE( hostware_dynobj_field               , NULL )
    PHP_FE( hostware_dynobj_set_field           , NULL )
    PHP_FE( hostware_dynobj_add_field           , NULL )
    PHP_FE( hostware_dynobj_xml                 , NULL )
    PHP_FE( hostware_dynobj_set_xml             , NULL )
/*
    PHP_FE( hostware_variable__new              , NULL )
    PHP_FE( hostware_variable__delete           , NULL )
    PHP_FE( hostware_variable_set_value         , NULL )
    PHP_FE( hostware_variable_value             , NULL )
    PHP_FE( hostware_variable_dim               , NULL )
    PHP_FE( hostware_variable_name              , NULL )
*/

    PHP_FE( hostware_session__new               , NULL )
    PHP_FE( hostware_session__delete            , NULL )
    PHP_FE( hostware_set_session                , NULL )

    { NULL, NULL, NULL }
};


zend_module_entry php_hostware_module_entry = 
{
#   if ZEND_MODULE_API_NO >= 20010901
	    STANDARD_MODULE_HEADER,         // ab PHP 4.2.1
#   endif

    "hostware",
    php_hostware_functions,
    PHP_MINIT(hostware),
    PHP_MSHUTDOWN(hostware),
    NULL,                               // PHP_RINIT(hostware),
    PHP_RSHUTDOWN(hostware),
    PHP_MINFO(hostware),

#   if ZEND_MODULE_API_NO >= 20010901
        VER_PRODUCTVERSION_STR,
#   endif

    STANDARD_MODULE_PROPERTIES
};


ZEND_GET_MODULE(php_hostware)

//--------------------------------------------------------------------PHP_MINIT_FUNCTION(hostware)

PHP_MINIT_FUNCTION(hostware)
{
    using namespace sos;
    using namespace php;

    //logfile << "PHP_MINIT_FUNCTION(hostware)\n" << flush;

    try {
        //Mutex_guard guard ( &semaphore );

        appl.init();

        string log_file = read_profile_string( "", "hostphp", "log" );
        if( !empty( log_file ) )  log_start( log_file );

        LOG( "PHP_MINIT_FUNCTION\n" );

        if( !SOS_LICENCE( licence_hostphp ) )  throw_xc( "SOS-1000", "hostPHP" );
    }
    catch( const exception& x )  
    {     
        string what = x.what();
        php_error( E_ERROR, "%s", c_str(what) );
        return E_ERROR;
    }

    return SUCCESS;
}

//----------------------------------------------------------------PHP_MSHUTDOWN_FUNCTION(hostware)

PHP_MSHUTDOWN_FUNCTION(hostware)
{
    using namespace sos;
    using namespace php;

    LOG( "PHP_MSHUTDOWN\n" );

    {
        Mutex_guard guard ( &semaphore );
        sessions.close();
    }

    //delete thread_data->_last_xc;
    //thread_data->_last_xc = NULL;

    appl.exit();

    return SUCCESS;
}

//----------------------------------------------------------------PHP_RSHUTDOWN_FUNCTION(hostware)

PHP_RSHUTDOWN_FUNCTION(hostware)
{
    using namespace sos;
    using namespace php;

    Mutex_guard guard ( &semaphore );

    //LOGI( "PHP_RSHUTDOWN\n" );

    if( thread_data )
    {
        LOG( "PHP_RSHUTDOWN  thread_data != NULL\n" );

        if( thread_data->_current_session )  
        {
            Mutex_guard guard ( &semaphore );
            sessions.close_object( thread_data->_current_session->index() );
            thread_data->_current_session = NULL;
        }

        delete thread_data->_last_xc;
        thread_data->_last_xc = NULL;
    }

    return SUCCESS;
}

//--------------------------------------------------------------------PHP_MINFO_FUNCTION(hostware) 

PHP_MINFO_FUNCTION(hostware)
{
    php_info_print_table_start();
    php_info_print_table_row(2, "hostWare Support", "enabled");
    php_info_print_table_row(2, "Compiled Version", VER_PRODUCTVERSION_STR );
    php_info_print_table_row(2, "Linked Version"  , VER_PRODUCTVERSION_STR );
    php_info_print_table_end();
}

} //extern "C"

//-----------------------------------------------------------------------------------------DllMain

#ifdef SYSTEM_WIN

namespace sos
{
    HINSTANCE _hinstance;
}

extern "C"      
BOOL WINAPI DllMain( HANDLE hInst, DWORD ul_reason_being_called, LPVOID )
{
    using namespace sos;
    using namespace php;

    switch( ul_reason_being_called )
    {
        case DLL_PROCESS_ATTACH: 
        {
            _CrtSetDbgFlag( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF );   // Speicherprfung bei _DEBUG
            _hinstance = (HINSTANCE)hInst; 
            appl.init();
            break;
        }

    	case DLL_PROCESS_DETACH: 
        {
            thread_data.thread_detach(); 
            appl.exit();
          //_CrtDumpMemoryLeaks();
            break;
        }

        case DLL_THREAD_ATTACH: 
            break;

    	case DLL_THREAD_DETACH: 
            if( thread_data )  thread_data.thread_detach(); 
            break;

        default: break;
    } 

    return TRUE;
}

#endif
