// $Id: hostphp_mit_hostole.cxx 3546 2005-04-03 08:30:29Z jz $

//#include <sstream>
#include "../zschimmer/com.h"
#include "../hostole/hostole_ptr.h"           // Hostole mit Exceptions (zschimmer.h)
#include "../kram/thread_semaphore.h"
#include "../zschimmer/zschimmer.h"
#include "../zschimmer/z_com.h"
#include "hostphp_version.h"

/*

libhostole.so  wegen sos.ini [hostole]
-------------

Kein [hostphp] log= mehr, sondern [hostole]

hostware_global.check_licence( "hostphp" )   prft zustzlich zu licence_hostole.
*/


#ifdef _WINDOWS
#   include <windows.h>

    // Header-Dateien fr php.h:
#   include <ios>
#   include <iostream>
#   include <strstream>
#   include <ios.h>
#   include <streamb.h>
#   include <strstrea.h>
#   include <math.h>    // Fr Microsoft Visual Studio C++ 6

#   define PHP_WIN32
#   define ZEND_WIN32
#   define ZTS          // Zend thread safe.  Sonst ist hostphp.dll nicht aufrufbar.

#   define EXPORT  _declspec(dllexport)

//  Wie aus php4ts.dll die php4ts.lib erzeugt wird, steht in 
//  http://support.microsoft.com/support/kb/ARTICLES/Q131/3/13.asp
//  (mit Hilfe von dumpbin php4ts.def schreiben und mit lib /def:php4ts.def die php4ts.lib erzeugen)

#   include <crtdbg.h>

# else

#   define EXPORT

#endif


#ifdef ZTS
#   define MY_TSRMLS_PARAM      TSRMLS_D
#   define MY_TSRMLS            TSRMLS_C
#else
#   define TSRMLS_PARAM void*           // Dummy
#   define MY_TSRMLS            NULL
#endif




//#define LOG(text)  log_hr = file->put_line( text );

#include <vector>

extern "C"
{
//  Folgende Include-Verzeichnisse von PHP mssen in den INCLUDE-Pfad aufgenommen werden:
//  .../php
//  .../php/main
//  .../php/Zend
//  .../php/TSRM

#   include "php.h"
#   include "ext/standard/info.h"

#   ifndef ZEND_DEBUG
#       define ZEND_DEBUG 0
#   endif

    //extern "C" int php_info_print_table_start(...);
    //extern "C" int php_info_print_table_row(...);
    //extern "C" int php_info_print_table_end(...);

    extern zend_module_entry hostware_module_entry;
#   define hostware_module_ptr &hostware_module_entry;

    PHP_MINIT_FUNCTION( hostware );
    PHP_MSHUTDOWN_FUNCTION( hostware );
    PHP_MINFO_FUNCTION( hostware );
}

#define CHECK_HR(hr,function)  if( FAILED(hr))  throw_com( hr, function )

//-----------------------------------------------------------------------------------GET_PHP_PARAMS

#define GET_PHP_PARAMS( MIN_COUNT, MAX_COUNT )                                                  \
    if( ARG_COUNT(ht) < MIN_COUNT  ||  ARG_COUNT(ht) > MAX_COUNT )  WRONG_PARAM_COUNT;          \
    pval* php_params[ MAX_COUNT ];                                                              \
    GET_PHP_PARAMS_##MAX_COUNT

#define GET_PHP_PARAMS_1                                                                        \
    if( getParameters( ht, min(1,ARG_COUNT(ht)), &php_params[0] ) == FAILURE )  WRONG_PARAM_COUNT
    
#define GET_PHP_PARAMS_2                                                                        \
    if( getParameters( ht, min(2,ARG_COUNT(ht)), &php_params[0], &php_params[1] ) == FAILURE )  WRONG_PARAM_COUNT
    
#define GET_PHP_PARAMS_3                                                                        \
    if( getParameters( ht, min(3,ARG_COUNT(ht)), &php_params[0], &php_params[1], &php_params[2] ) == FAILURE )  WRONG_PARAM_COUNT
    
//-----------------------------------------------------------------------------GET_PHP_PARAM_STRING

#define GET_PHP_PARAM_STRING(NR,NAME)                                                           \
    Bstr NAME##_bstr;                                                                           \
    if( ARG_COUNT(ht) >= NR ) {                                                                 \
        if( php_params[NR-1]->type != IS_STRING )  throw_xc( "SOS-PHP-103", #NAME, "String" );  \
        NAME##_bstr.Attach( bstr_from_string( php_params[NR-1]->value.str.val, php_params[NR-1]->value.str.len ) ); \
    }                                                                                           \
    else                                                                                        \
        NAME##_bstr = L"";

//--------------------------------------------------------------------------GET_PHP_PARAM_AS_STRING

#define GET_PHP_PARAM_AS_STRING(NR,NAME)                                                        \
    Bstr NAME##_bstr;                                                                           \
    if( ARG_COUNT(ht) >= NR ) {                                                                 \
        convert_to_string( php_params[NR-1] );                                                  \
        NAME##_bstr.Attach( bstr_from_string( php_params[NR-1]->value.str.val, php_params[NR-1]->value.str.len ); \
    }                                                                                           \
    else                                                                                        \
        NAME##_bstr = L"";

//-------------------------------------------------------------------------------GET_PHP_PARAM_LONG

#define GET_PHP_PARAM_LONG(NR,NAME)                                                             \
    long     NAME = 0;                                                                          \
    if( ARG_COUNT(ht) >= NR ) {                                                                 \
        if( php_params[NR-1]->type != IS_LONG )  throw_xc( "SOS-PHP-103", #NAME, "Long" );      \
        NAME = php_params[NR-1]->value.lval;                                                    \
    }

//----------------------------------------------------------------------------GET_PHP_PARAM_VARIANT

#define GET_PHP_PARAM_VARIANT(NR,NAME)                                                          \
    Variant NAME##_vt;                                                                          \
                                                                                                \
    if( ARG_COUNT(ht) >= NR ) {                                                                 \
        pval_to_variant( php_params[NR-1], &NAME##_vt );                                        \
    }

//-------------------------------------------------------------------------------GET_PHP_PARAM_FILE

#define GET_PHP_PARAM_FILE(NR,NAME)                                                             \
    Ihostware_file_ptr NAME = 0;                                                                \
    if( ARG_COUNT(ht) >= NR ) {                                                                 \
        if( php_params[NR-1]->type != IS_LONG )  throw_xc( "SOS-PHP-103", #NAME, "Long" );      \
        NAME = file_by_index( php_params[NR-1] );                                               \
    }

//-----------------------------------------------------------------------------GET_PHP_PARAM_RECORD

#define GET_PHP_PARAM_RECORD(NR,NAME)                                                           \
    Ihostware_dynobj_ptr NAME = 0;                                                              \
    if( ARG_COUNT(ht) >= NR ) {                                                                 \
        if( php_params[NR-1]->type != IS_LONG )  throw_xc( "SOS-PHP-103", #NAME, "Long" );      \
        NAME = record_by_index( php_params[NR-1] );                                             \
    }

//--------------------------------------------------------------------------------------RETURN_BSTR

#define RETURN_BSTR(BSTR)                                                                       \
    {                                                                                           \
        string result = string_from_bstr( BSTR );                                               \
        RETURN_STRINGL( (char*)result.c_str(), result.length(), true );                         \
    }

//----------------------------------------------------------------------------------------------LOG

#define LOG( TEXT )                                                                             \
    do {                                                                                        \
        if( log_file )                                                                          \
        {                                                                                       \
            ::std::ostrstream _logstream_;                                                      \
            _logstream_ << TEXT;                                                                \
            Bstr _log_bstr_ ( _logstream_.str(), _logstream_.pcount() );                        \
            _logstream_.freeze(0);                                                              \
            log_file.put_line( _log_bstr_ );                                                    \
        }                                                                                       \
    } while(0)                                                                                  

//-------------------------------------------------------------------------------------------------


using namespace std;
using namespace zschimmer;
using namespace zschimmer::com;
using sos::Thread_semaphore;

namespace hostphp {


struct File;

static Bstr                             empty_bstr = L"";
static vector< Ihostware_file_ptr >     file_array;     // Nicht mehrfdig
static vector< Ihostware_dynobj_ptr >   record_array;   // Nicht mehrfdig
static Thread_semaphore                 semaphore;
static int                              error_mode = E_WARNING;
static Xc*                              last_xc;
static Ihostware_ptr                    hostware;
static Ihostware_file_ptr               log_file;

#ifdef _WIN32
    static DWORD                        hostware_thread_id;
#endif

//-------------------------------------------------------------------------------------------------

Error_code_text error_texts[] =
{
    { "SOS-PHP-101"                     , "Dynobj-Nummer $1 ist ungltig" },
    { "SOS-PHP-102"                     , "Dateinummer $1 ist ungltig" },
    { "SOS-PHP-103"                     , "Parameter $1 ist nicht vom Typ $2" },
    { NULL                              , NULL }
};

//----------------------------------------------------------------------------------pval_to_variant

static void pval_to_variant( pval* value_php, VARIANT* vt )
{
    VariantClear( vt );

    switch( value_php->type ) 
    {
        case IS_BOOL:   vt->vt = VT_BOOL;  V_BOOL(vt) = value_php->value.lval? true : false;      break;
        case IS_LONG:   vt->vt = VT_I4;    V_I4(vt)   = value_php->value.lval;                    break;
        case IS_DOUBLE: vt->vt = VT_R8;    V_R8(vt)   = value_php->value.dval;                    break;

        default: 
        {
            convert_to_string( value_php );

            vt->vt = VT_BSTR;
            V_BSTR( vt ) = bstr_from_string( value_php->value.str.val );
        }
    }
}

//-----------------------------------------------------------------------------------return_variant

static void return_variant( const VARIANT& vt, pval* return_value )
{
    HRESULT hr;

    switch( vt.vt )
    {
        case VT_NULL:    RETVAL_NULL();                      break;
        case VT_I1:      RETVAL_LONG  ( V_I1(&vt) );      break;
        case VT_UI1:     RETVAL_LONG  ( V_UI1(&vt) );     break;
        case VT_I2:      RETVAL_LONG  ( V_I2(&vt) );      break;
        case VT_UI2:     RETVAL_LONG  ( V_UI2(&vt) );     break;
        case VT_I4:      RETVAL_LONG  ( V_I4(&vt) );      break;
        case VT_UI4:     RETVAL_LONG  ( V_I2(&vt) );      break;
        case VT_INT:     RETVAL_LONG  ( V_INT(&vt) );     break;
        case VT_UINT:    RETVAL_LONG  ( V_UINT(&vt) );    break;
        case VT_R8:      RETVAL_DOUBLE( V_R8(&vt) );      break;
        case VT_R4:      RETVAL_DOUBLE( V_R4(&vt) );      break;
        case VT_BOOL:    RETVAL_BOOL  ( V_BOOL(&vt) );    break;

        default:
        {
            string str;
            
            if( vt.vt == VT_BSTR )  
            {
                str = string_from_bstr( V_BSTR(&vt) );
            }
            else
            if( vt.vt == VT_DATE )
            {
                Bstr bstr;

                hostware.date_as_string( (VARIANT*)&vt, empty_bstr, &bstr );

                str = string_from_bstr(bstr);
            }
            else
            { 
                Variant copy = vt;

                hr = copy.ChangeType( VT_BSTR );
                CHECK_HR( hr, "VariantChangeType" );

                str = string_from_bstr( V_BSTR( &copy ) );
            }

            RETVAL_STRINGL( (char*)str.c_str(), str.length(), true );
        }
    }
}

//----------------------------------------------------------------------------------variant_to_pval
/*
static void variant_to_pval( const VARIANT& vt, pval* value_php )
{
    switch( vt.vt )
    {
        VT_NULL:    RETURN_NULLvalue_php->type = IS_NULL;  break;
        VT_I2:      value_php->type = IS_LONG;  value_php->value.lval = V_I2(result);  break;
        VT_I4:      value_php->type = IS_LONG;  value_php->value.lval = V_I4(result);  break;
        VT_R8:      value_php->type = IS_DOUBLE;  value_php->value.dval = V_R4(result);  break;
        VT_R4:      value_php->type = IS_DOUBLE;  value_php->value.dval = V_R8(result);  break;
        VT_BOOL:    value_php->type = IS_BOOL;  value_php->value.lval = V_BOOL(result);  break;
        VT_BSTR:    value_php->type = IS_STRING;  value_php->value.lval = V_BOOL(result);  break;
        VT_I2:      value_php->type = IS_LONG;  value_php->value.lval = V_I2(result);  break;
        VT_I4:      value_php->type = IS_LONG;  value_php->value.lval = V_I4(result);  break;
        VT_R8:      value_php->type = IS_DOUBLE;  value_php->value.dval = V_R4(result);  break;
        VT_R4:      value_php->type = IS_DOUBLE;  value_php->value.dval = V_R8(result);  break;
        VT_BOOL:    value_php->type = IS_BOOL;  value_php->value.lval = V_BOOL(result);  break;
        VT_BSTR:    value_php->type = IS_STRING;  value_php->value.lval = V_BOOL(result);  break;
    }
}
*/
//--------------------------------------------------------------------------------------------begin

static void begin()
{
    //if( !SOS_LICENCE( licence_hostphp ) )  throw_xc( "SOS-1000", "hostPHP" );

    //SOS_DELETE( last_xc );
}

//------------------------------------------------------------------------------------file_by_index

static Ihostware_file* file_by_index( pval* php_file_nr )
{
    if( php_file_nr->type != IS_LONG )  throw_xc( "SOS-PHP-103", "file", "long" );

    int file_nr = php_file_nr->value.lval;

    if( file_nr > 0  &&  (unsigned int)file_nr < file_array.size() )
    {
        Thread_semaphore::Guard guard ( &semaphore );
        Ihostware_file* file = file_array[ file_nr ];
        if( file )  return file;
    }

    throw_xc( "SOS-PHP-102", file_nr );
    return NULL;
}

//----------------------------------------------------------------------------------record_by_index

static Ihostware_dynobj* record_by_index( pval* php_record_nr )
{
    if( php_record_nr->type != IS_LONG )  throw_xc( "SOS-PHP-103", "record", "long" );

    int record_nr = php_record_nr->value.lval;

    if( record_nr > 0  &&  (unsigned int)record_nr < record_array.size() )
    {
        Thread_semaphore::Guard guard ( &semaphore );
        Ihostware_dynobj* record = record_array[ record_nr ];
        if( record )  return record;
    }

    throw_xc( "SOS-PHP-101", record_nr );
    return NULL;
}

//-----------------------------------------------------------------------------------enter_new_file

static int enter_new_file( Ihostware_file_ptr file )
{
    Thread_semaphore::Guard guard ( &semaphore );
    int i;

    if( file_array.size() == 0 )  file_array.push_back(NULL);       // [0] wird nicht benutzt

    for( i = 1; i < (int)file_array.size(); i++ )  if( file_array[i] == NULL )  break;

    if( i == (int)file_array.size() )  file_array.push_back( file );
                                 else  file_array[i] = file;

    return i;
}

//---------------------------------------------------------------------------------enter_new_record

static int enter_new_record( Ihostware_dynobj_ptr record )
{
    Thread_semaphore::Guard guard ( &semaphore );
    int i;

    if( record_array.size() == 0 )  record_array.push_back(NULL);       // [0] wird nicht benutzt

    for( i = 1; i < (int)record_array.size(); i++ )  if( record_array[i] == NULL )  break;
    
    if( i == (int)record_array.size() )  record_array.push_back( record );
                                   else  record_array[i] = record;

    return i;
}

//---------------------------------------------------------------------------------exception_to_php
/*
void exception_to_php( const exception& x )
{
    delete last_xc;
    last_xc = new Xc( x );

    if( error_mode ) 
    {
        string what = x.what();
        php_error( error_mode, "%s", c_str(what) );
    }
}
*/
//---------------------------------------------------------------------------------exception_to_php

void exception_to_php( const Xc& x )
{
    delete last_xc;
    last_xc = new Xc( x );

    if( error_mode ) 
    {
        string what = x.what();
        php_error( error_mode, "%s", c_str(what) );
    }
}

//-----------------------------------------------------------------------------------pval_to_record
/*
static void pval_to_record( pval* value_php, Dyn_obj* record )
{
    static const bool true_value  = true;
    static const bool false_value = false;

    switch( value_php->type ) 
    {
        case IS_BOOL:
        {
            record->assign( &bool_type, value_php->value.lval? &true_value : &false_value );  
            break;
        }

        case IS_LONG:
        {
            record->assign( &long_type, &value_php->value.lval );  
            break;
        }

        case IS_DOUBLE: 
        {
            record->assign( &double_type, &value_php->value.dval );  
            break;
        }

        default: 
        {
            convert_to_string( value_php );
            *record = value_php->value.str.val;
        }
    }
}
*/
//-------------------------------------------------------------------------hostware_copy_file

extern "C" EXPORT PHP_FUNCTION( hostware_copy_file )
{
    try 
    {
        begin();

        //LOGI( "hostware_copy_file()\n" );

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_STRING( 1, source_filename );
        GET_PHP_PARAM_STRING( 2, dest_filename   );
        
        hostware.copy_file( source_filename_bstr, dest_filename_bstr );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//------------------------------------------------------------------------hostware_remove_file

extern "C" EXPORT PHP_FUNCTION( hostware_remove_file )
{
    try 
    {
        //LOGI( "hostware_remove_file()\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_STRING( 1, filename );

        hostware.remove_file( filename_bstr );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//-------------------------------------------------------------------------hostware_rename_file

extern "C" EXPORT PHP_FUNCTION( hostware_rename_file )
{
    try {
        Thread_semaphore::Guard guard ( &semaphore );

        //LOGI( "hostware_rename_file()\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_STRING( 1, old_filename );
        GET_PHP_PARAM_STRING( 2, new_filename );

        hostware.rename_file( old_filename_bstr, new_filename_bstr );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//-----------------------------------------------------------------------hostware_file_as_string

extern "C" EXPORT PHP_FUNCTION( hostware_file_as_string )
{
    try 
    {
        //LOGI( "hostware_file_as_string()\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_STRING( 1, filename );

        Bstr result_bstr;

        hostware.file_as_string( filename_bstr, &result_bstr );

        RETURN_BSTR( result_bstr )
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//--------------------------------------------------------------------------php_params_to_safearray

static void php_params_to_safearray( MY_TSRMLS_PARAM, int ht, SAFEARRAY** safearray )
{
    *safearray = NULL;

    const int   max_params   = 30;
    pval*       php_filename = NULL;
    pval*       php_params[ max_params ];
    HRESULT     hr;
  //SAFEARRRAYBOUNDS bounds;

  //bounds[0].lLbound   = 0;

    
    if( ARG_COUNT(ht) < 1  ||  ARG_COUNT(ht) > 1+max_params )  WRONG_PARAM_COUNT

    getParameters( ht, ARG_COUNT(ht), &php_filename, &php_params[0],
                                                     &php_params[1],
                                                     &php_params[2],
                                                     &php_params[3],
                                                     &php_params[4],
                                                     &php_params[5],
                                                     &php_params[6],
                                                     &php_params[7],
                                                     &php_params[8],
                                                     &php_params[9],
                                                     &php_params[10],
                                                     &php_params[11],
                                                     &php_params[12],
                                                     &php_params[13],
                                                     &php_params[14],
                                                     &php_params[15],
                                                     &php_params[16],
                                                     &php_params[17],
                                                     &php_params[18],
                                                     &php_params[19],
                                                     &php_params[20],
                                                     &php_params[21],
                                                     &php_params[22],
                                                     &php_params[23],
                                                     &php_params[24],
                                                     &php_params[25],
                                                     &php_params[26],
                                                     &php_params[27],
                                                     &php_params[28],
                                                     &php_params[29] );

    if( php_filename->type != IS_STRING )  throw_xc( "SOS-PHP-103", "filename", "String" );

    if( ARG_COUNT(ht) == 2  &&  php_params[0]->type == IS_ARRAY )
    {
        zval** param1;
        zval** zend_array = NULL;
        zval** current    = NULL;

        zend_get_parameters_ex( 2, &param1, &zend_array );
        HashTable* zend_hash = HASH_OF( *zend_array );
        long i = 0;
        int n = 0;

        for( zend_hash_internal_pointer_reset( zend_hash );
             zend_hash_get_current_data( zend_hash, (void**)&current ) == SUCCESS;
             zend_hash_move_forward( zend_hash ) )
        {
            n++;
        }

        *safearray = SafeArrayCreateVector( VT_VARIANT, 0, n );

        for( zend_hash_internal_pointer_reset( zend_hash );
             zend_hash_get_current_data( zend_hash, (void**)&current ) == SUCCESS;
             zend_hash_move_forward( zend_hash ) )
        {
            //SEPARATE_ZVAL( current );

            VARIANT* element = NULL;

            hr = SafeArrayPtrOfIndex( *safearray, &i, (void**)&element );
            CHECK_HR( hr, "SafeArrayPtrOfIndex" );

            pval_to_variant( *current, element );
            i++;
        }
    }
    else
    {
        int n = ARG_COUNT(ht) - 1;
        //bounds[0].cElements = n;
        //*safearray = SafeArrayCreate( VT_VARIANT, 1, bounds );
        *safearray = SafeArrayCreateVector( VT_VARIANT, 0, n );

        for( long i = 0; i < n; i++ ) 
        {
            VARIANT* element = NULL;

            hr = SafeArrayPtrOfIndex( *safearray, &i, (void**)&element );
            CHECK_HR( hr, "SafeArrayPtrOfIndex" );

            pval_to_variant( php_params[i], element );
            i++;
        }
    }
}

//--------------------------------------------------------------------------hostware_get_single_

extern "C" EXPORT PHP_FUNCTION( hostware_get_single_ )
{
    SAFEARRAY* safearray = NULL;

    try 
    {
        //LOGI( "hostware_file_get_single\n" );
        begin();

        pval* php_params[1];
        if( ARG_COUNT(ht) < 1 )  WRONG_PARAM_COUNT;
        GET_PHP_PARAMS_1;
        GET_PHP_PARAM_STRING( 1, filename );

        php_params_to_safearray( MY_TSRMLS, ht, &safearray );

        RETURN_LONG( enter_new_record( hostware.get_single( filename_bstr, safearray ) ) ); 
    }
    catch( const Xc& x )  { exception_to_php(x); }

    SafeArrayDestroy( safearray );
}

//--------------------------------------------------------------------------hostware_get_array_

extern "C" EXPORT PHP_FUNCTION( hostware_get_array_ )
{
    SAFEARRAY* safearray = NULL;

    try 
    {
        HRESULT hr;
        //LOGI( "hostware_file_get_array\n" );
        begin();

        Ihostware_file_ptr file;

        hr = file.CoCreateInstance( L"Hostware.File" );
        CHECK_HR( hr, "CoCreateInstance" );

        pval* php_params[1];
        if( ARG_COUNT(ht) < 1 )  WRONG_PARAM_COUNT;
        GET_PHP_PARAMS_1;
        GET_PHP_PARAM_STRING( 1, filename );
        php_params_to_safearray( MY_TSRMLS, ht, &safearray );

        file.prepare( filename_bstr );
        file.set_parameters( safearray );
        file.open( empty_bstr );

        if( array_init(return_value) == FAILURE )  throw_xc( "SOS-PHP-array_init" );

        while(1)
        {
            if( file.eof() )  break;
            add_next_index_long( return_value, enter_new_record( file.get() ) );
        }

        file.close();
    }
    catch( const Xc& x )  { exception_to_php(x); }

    SafeArrayDestroy( safearray );
}

//-----------------------------------------------------------------------hostware_execute_direct

extern "C" EXPORT PHP_FUNCTION( hostware_execute_direct )
{
    SAFEARRAY* safearray = NULL;

    try 
    {
        //LOGI( "hostware_file_get_single\n" );
        begin();

        pval* php_params[1];
        if( ARG_COUNT(ht) < 1 )  WRONG_PARAM_COUNT;
        GET_PHP_PARAMS_1;
        GET_PHP_PARAM_STRING( 1, statement );

        php_params_to_safearray( MY_TSRMLS, ht, &safearray );

        hostware.execute_direct( statement_bstr, safearray );
    }
    catch( const Xc& x )  { exception_to_php(x); }

    SafeArrayDestroy( safearray );
}

//---------------------------------------------------------------------------------hostware_as_date

extern "C" EXPORT PHP_FUNCTION( hostware_as_date )
{
    try 
    {
        begin();

        GET_PHP_PARAMS(1,2);
        GET_PHP_PARAM_STRING( 1, date );
        GET_PHP_PARAM_STRING( 2, format );

        Variant date_vt;
        date_vt.vt = VT_DATE;
        date_vt.date = hostware.as_date( date_bstr, format_bstr );

        Bstr result_bstr;

        hostware.date_as_string( &date_vt, empty_bstr, &result_bstr );

        RETURN_BSTR( result_bstr );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//--------------------------------------------------------------------------hostware_date_as_string

extern "C" EXPORT PHP_FUNCTION( hostware_date_as_string )
{
    try 
    {
        begin();

        GET_PHP_PARAMS(1,2);
        GET_PHP_PARAM_STRING( 1, date   );
        GET_PHP_PARAM_STRING( 2, format );

        Variant date_vt;
        date_vt.vt = VT_DATE;
        date_vt.date = hostware.as_date( date_bstr, empty_bstr );
        Bstr result_bstr;

        hostware.date_as_string( &date_vt, format_bstr, &result_bstr );
        
        RETURN_BSTR( result_bstr );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//---------------------------------------------------------------------------------hostware_as_xml_

extern "C" EXPORT PHP_FUNCTION( hostware_as_xml_ )
{
    try 
    {
        begin();

        GET_PHP_PARAMS(1,2);
        GET_PHP_PARAM_VARIANT( 1, value );
        GET_PHP_PARAM_STRING ( 2, options );

        Bstr result_bstr;
/*
        if( value_php->type == IS_LONG )    // Dynobj?
        {
            Ihostware_dynobj* o = record_by_index( value_php->value.lval );
            result = o->as_xml();
        }
        else
*/
        {
            hostware.as_xml( &value_vt, options_bstr, &result_bstr );
        }

        RETURN_BSTR( result_bstr );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//---------------------------------------------------------------------------hostware_from_xml

extern "C" EXPORT PHP_FUNCTION( hostware_from_xml )
{
    try 
    {
        begin();

        GET_PHP_PARAMS(1,2);
        GET_PHP_PARAM_STRING( 1, xml_text );
        GET_PHP_PARAM_STRING( 1, options );

        Bstr result_bstr;

        hostware.from_xml( xml_text_bstr, options_bstr, &result_bstr );

        RETURN_BSTR( result_bstr );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//---------------------------------------------------------------------------hostware_sql_equal

extern "C" EXPORT PHP_FUNCTION( hostware_sql_equal )
{
    try 
    {
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_STRING ( 1, field_name );
        GET_PHP_PARAM_VARIANT( 2, value );


        Bstr result_bstr;

        hostware.sql_equal( field_name_bstr, value_vt, &result_bstr );

        RETURN_BSTR( result_bstr );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//---------------------------------------------------------------------------hostware_sql_quoted

extern "C" EXPORT PHP_FUNCTION( hostware_sql_quoted )
{
    try 
    {
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_VARIANT( 1, value );

        Bstr result_bstr;
        hostware.sql_quoted( value_vt, &result_bstr );

        RETURN_BSTR( result_bstr );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//---------------------------------------------------------------------------hostware_file_exists

extern "C" EXPORT PHP_FUNCTION( hostware_file_exists )
{
    try 
    {
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_STRING( 1, filename );

        RETURN_BOOL( hostware.file_exists( filename_bstr ) );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//---------------------------------------------------------------------------hostware_make_path

extern "C" EXPORT PHP_FUNCTION( hostware_make_path )
{
    try 
    {
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_STRING( 1, filename );

        hostware.make_path( filename_bstr );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//----------------------------------------------------------------------hostware_set_error_mode

extern "C" EXPORT PHP_FUNCTION( hostware_set_error_mode )
{
    try {
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_LONG( 1, mode );

        error_mode = mode;
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//-------------------------------------------------------------------------------hostware_error

extern "C" EXPORT PHP_FUNCTION( hostware_error )
{
    try {
        Thread_semaphore::Guard guard ( &semaphore );
        //begin() lscht last_xc

        if( ARG_COUNT(ht) != 0 )  WRONG_PARAM_COUNT;
        RETURN_BOOL( last_xc != NULL );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//----------------------------------------------------------------------hostware_exception_name

extern "C" EXPORT PHP_FUNCTION( hostware_exception_name )
{
    try {
        Thread_semaphore::Guard guard ( &semaphore );
        //begin() lscht last_xc

        if( ARG_COUNT(ht) != 0 )  WRONG_PARAM_COUNT;

        if( last_xc )  { RETVAL_STRING( (char*)last_xc->name().c_str(), true ); }
                 else  { RETVAL_STRING( "", true ); }

    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//--------------------------------------------------------------------------hostware_error_code

extern "C" EXPORT PHP_FUNCTION( hostware_error_code )
{
    try {
        Thread_semaphore::Guard guard ( &semaphore );
        //begin() lscht last_xc

        if( ARG_COUNT(ht) != 0 )  WRONG_PARAM_COUNT;

        if( last_xc )  { RETVAL_STRING( (char*)last_xc->code().c_str(), true ); }
                 else  { RETVAL_STRING( "", true ); }

    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//--------------------------------------------------------------------------hostware_error_text

extern "C" EXPORT PHP_FUNCTION( hostware_error_text )
{
    try {
        Thread_semaphore::Guard guard ( &semaphore );
        //begin() lscht last_xc

        if( ARG_COUNT(ht) != 0 )  WRONG_PARAM_COUNT;

        if( last_xc ) 
        { 
            string text = last_xc->what();
            RETVAL_STRING( (char*)text.c_str(), true ); 
        }
        else 
        { 
            RETVAL_STRING( "", true ); 
        }

    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//-------------------------------------------------------------------------------hostware_file__new

extern "C" EXPORT PHP_FUNCTION( hostware_file__new )
{
    try 
    {
        HRESULT hr;
        Thread_semaphore::Guard guard ( &semaphore );
        //LOGI( "hostware_file__new()\n" );
        begin();

        if( ARG_COUNT(ht) != 0 )  WRONG_PARAM_COUNT;

        Ihostware_file_ptr file;
        
        hr = file.CoCreateInstance( L"Hostware.File" );
        CHECK_HR( hr, "CoCreateInstance Hostware.File" );

        RETURN_LONG( enter_new_file( file ) );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//----------------------------------------------------------------------------hostware_file__delete

extern "C" EXPORT PHP_FUNCTION( hostware_file__delete )
{
    try 
    {
        Thread_semaphore::Guard guard ( &semaphore );

        //LOGI( "hostware_file__delete()\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_LONG( 1, filenr );

        file_by_index( php_params[0] );  // prft Index
        file_array[ filenr ] = NULL;
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//----------------------------------------------------------------------------hostware_file_prepare

extern "C" EXPORT PHP_FUNCTION( hostware_file_prepare )
{
    try 
    {
        //LOGI( "hostware_file_prepare\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_STRING( 2, filename );

        file.prepare( filename_bstr );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//----------------------------------------------------------------------hostware_file_set_parameter

extern "C" EXPORT PHP_FUNCTION( hostware_file_set_parameter )
{
    try 
    {
        //LOGI( "hostware_file_set_parameter\n" );
        begin();

        GET_PHP_PARAMS(3,3);
        GET_PHP_PARAM_FILE   ( 1, file );
        GET_PHP_PARAM_LONG   ( 2, nr );
        GET_PHP_PARAM_VARIANT( 3, value );

        file.set_parameter( nr, &value_vt );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//----------------------------------------------------------------------------hostware_file_execute

extern "C" EXPORT PHP_FUNCTION( hostware_file_execute )
{
    try 
    {
        //LOGI( "hostware_file_execute\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_FILE( 1, file );

        file.execute();
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//-------------------------------------------------------------------------------hostware_file_open

extern "C" EXPORT PHP_FUNCTION( hostware_file_open )
{
    try 
    {
        //LOGI( "hostware_file_open()\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_STRING( 2, filename );

        file.open( filename_bstr );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//------------------------------------------------------------------------------hostware_file_close

extern "C" EXPORT PHP_FUNCTION( hostware_file_close )
{
    try 
    {
        //LOGI( "hostware_file_close()\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_FILE( 1, file );

        file.close();
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//-----------------------------------------------------------------------hostware_file_close_cursor

extern "C" EXPORT PHP_FUNCTION( hostware_file_close_cursor )
{
    try 
    {
        //LOGI( "hostware_file_close_cursor\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_FILE( 1, file );

        file.close_cursor();
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//-----------------------------------------------------------------------------hostware_file_opened

extern "C" EXPORT PHP_FUNCTION( hostware_file_opened )
{
    try 
    {
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_FILE( 1, file );

        RETURN_BOOL( file.opened() );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//--------------------------------------------------------------------------------hostware_file_eof

extern "C" EXPORT PHP_FUNCTION( hostware_file_eof )
{
    try 
    {
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_FILE( 1, file );

        RETURN_BOOL( file.eof() );
    }   
    catch( const Xc& x )  { exception_to_php(x); }
}                                                 

//----------------------------------------------------------------------hostware_file_create_record

extern "C" EXPORT PHP_FUNCTION( hostware_file_create_record )
{
    try 
    {
        //LOGI( "hostware_file_create_record\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_FILE( 1, file );

        RETURN_LONG( enter_new_record( file.create_record() ) );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//-------------------------------------------------------------------------hostware_file_create_key

extern "C" EXPORT PHP_FUNCTION( hostware_file_create_key )
{
    try 
    {
        //LOGI( "hostware_file_create_key\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_FILE( 1, file );

        RETURN_LONG( enter_new_record( file.create_key() ) );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//---------------------------------------------------------------------------hostware_file_get_line

extern "C" EXPORT PHP_FUNCTION( hostware_file_get_line )
{
    try 
    {
        //LOGI( "hostware_file_get_line\n" );
        begin();


        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_FILE( 1, file );


        Bstr result_bstr;

        file.get_line( &result_bstr );

        RETURN_BSTR( result_bstr );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//--------------------------------------------------------------------------------hostware_file_get

extern "C" EXPORT PHP_FUNCTION( hostware_file_get )
{
    try 
    {
        //LOGI( "hostware_file_get\n" );
        begin();


        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_FILE( 1, file );

        RETURN_LONG( enter_new_record( file.get() ) );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//-----------------------------------------------------------------------------hostware_file_rewind

extern "C" EXPORT PHP_FUNCTION( hostware_file_rewind )
{
    try 
    {
        //LOGI( "hostware_file_rewind\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_FILE( 1, file );

        file.rewind();
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//--------------------------------------------------------------------------------hostware_file_put

extern "C" EXPORT PHP_FUNCTION( hostware_file_put )
{
    try 
    {
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_RECORD( 2, record );

        Variant record_vt = (IDispatch*)record;
        file.put( &record_vt );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//---------------------------------------------------------------------------hostware_file_put_line

extern "C" EXPORT PHP_FUNCTION( hostware_file_put_line )
{
    try 
    {
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_STRING( 2, line );

        file.put_line( line_bstr );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//----------------------------------------------------------------------------hostware_file_set_key

extern "C" EXPORT PHP_FUNCTION( hostware_file_set_key )
{
    try 
    {
        //LOGI( "hostware_file_set_key\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_RECORD( 2, key );

        Variant key_vt = (IDispatch*)key;

        file.set_key( &key_vt );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//-------------------------------------------------------------------------hostware_file_delete_key

extern "C" EXPORT PHP_FUNCTION( hostware_file_delete_key )
{
    try 
    {
        //LOGI( "hostware_file_set_key\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_RECORD( 2, key );

        Variant key_vt = (IDispatch*)key;
        file.delete_key( &key_vt );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//----------------------------------------------------------------------------hostware_file_get_key

extern "C" EXPORT PHP_FUNCTION( hostware_file_get_key )
{
    try 
    {
        //LOGI( "hostware_file_get_key\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_RECORD( 2, key );

        Variant key_vt = (IDispatch*)key;

        RETURN_LONG( enter_new_record( file.get_key( &key_vt ) ) );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//----------------------------------------------------------------------------hostware_file_insert

extern "C" EXPORT PHP_FUNCTION( hostware_file_insert )
{
    try 
    {
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_RECORD( 2, record );

        Variant record_vt = (IDispatch*)record;
        
        file.insert( &record_vt );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//-----------------------------------------------------------------------------hostware_file_update

extern "C" EXPORT PHP_FUNCTION( hostware_file_update )
{
    try 
    {
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_RECORD( 2, record );

        Variant record_vt = (IDispatch*)record;

        file.update( &record_vt );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//----------------------------------------------------------------------hostware_file_update_direct
                                                                      
extern "C" EXPORT PHP_FUNCTION( hostware_file_update_direct )
{
    try 
    {
        //LOGI( "hostware_file_update_direct\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_RECORD( 2, record );

        Variant record_vt = (IDispatch*)record;

        file.update_direct( &record_vt );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//------------------------------------------------------------------------------hostware_file_store

extern "C" EXPORT PHP_FUNCTION( hostware_file_store )
{
    try 
    {
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_RECORD( 2, record );

        Variant record_vt = (IDispatch*)record;

        file.store( &record_vt );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//--------------------------------------------------------------------hostware_file_set_date_format

extern "C" EXPORT PHP_FUNCTION( hostware_file_set_date_format )
{
    try 
    {
        //LOGI( "hostware_file_put_date_format\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_STRING( 2, format );

        file.set_date_format( format_bstr );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//----------------------------------------------------------------hostware_file_set_date_time_format

extern "C" EXPORT PHP_FUNCTION( hostware_file_set_date_time_format )
{
    try 
    {
        //LOGI( "hostware_file_put_date_format\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_STRING( 2, format );

        file.set_date_time_format( format_bstr );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//-----------------------------------------------------------------hostware_file_set_decimal_symbol

extern "C" EXPORT PHP_FUNCTION( hostware_file_set_decimal_symbol )
{
    try 
    {
        //LOGI( "hostware_file_put_date_format\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE  ( 1, file );
        GET_PHP_PARAM_STRING( 2, symbol );

        file.set_decimal_symbol( symbol_bstr );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//-------------------------------------------------------------------------hostware_file_field_name

extern "C" EXPORT PHP_FUNCTION( hostware_file_field_name )
{
    try 
    {
        //LOGI( "hostware_file_field_name\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE( 1, file );
        GET_PHP_PARAM_LONG( 2, fieldnr );

        Bstr result_bstr;

        file.get_field_name( fieldnr, &result_bstr );

        RETURN_BSTR( result_bstr );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//------------------------------------------------------------------------hostware_file_field_count

extern "C" EXPORT PHP_FUNCTION( hostware_file_field_count )
{
    try 
    {
        //LOGI( "hostware_file_field_count\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_FILE( 1, file );

        RETURN_LONG( file.field_count() );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//-------------------------------------------------------------hostware_file_set_write_empty_as_null

extern "C" EXPORT PHP_FUNCTION( hostware_file_set_write_empty_as_null )
{
    try 
    {
        //LOGI( "hostware_file_set_write_empty_as_null\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_FILE( 1, file );
        GET_PHP_PARAM_LONG( 2, value );

        file.set_write_empty_as_null( value );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//---------------------------------------------------------------Ihostware_dynobj::Ihostware_dynobj
/*
Ihostware_dynobj::Ihostware_dynobj( Record_type* type, Ihostware_file* file )
:
    _type ( type );
{
    if( !SOS_LICENCE( licence_hostphp ) )  throw_xc( "SOS-1000", "hostPHP" );

    //?jz 1.6.98  if( !_type )  _type = Record_type::create();

    // Parameter file nicht merken, wird evtl. vor diesem Objekt geschlossen!
    if( file ) {
        _text_format = hr = file->_text_format;
        _write_empty_as_null = hr = file->_write_empty_as_null;
    }

    if( _type )  _record.allocate_min( _type->field_size() );
}
*/
//------------------------------------------------------------------------hostware_dynobj__delete

extern "C" EXPORT PHP_FUNCTION( hostware_dynobj__delete )
{
    try 
    {
        Thread_semaphore::Guard guard ( &semaphore );

        //LOGI( "hostware_dynobj__delete()\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_LONG( 1, record_nr );

        record_by_index( php_params[0] );  // prft Index

        record_array[ record_nr ] = NULL;
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//-------------------------------------------------------------------------Ihostware_dynobj::index
/*
int Ihostware_dynobj::index()
{
    if( _index == 0 )
    {
        uint i;
        for( i = 1; i < record_array.size(); i++ )  if( record_array[i] == NULL )  break;
        if( i >= record_array.size() )  record_array.resize( record_array.size() + 100 );

        _index = i;
        record_array[_index] = this;
    }

    return _index;
}
*/
//--------------------------------------------------------------------------hostware_dynobj_clone

extern "C" EXPORT PHP_FUNCTION( hostware_dynobj_clone )
{
    try 
    {
      //LOGI( "Ihostware_dynobj::clone\n" );
        begin();

        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_RECORD( 1, record );

        RETURN_LONG( enter_new_record( record.clone() ) );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//-------------------------------------------------------hostware_dynobj_set_write_empty_as_null

extern "C" EXPORT PHP_FUNCTION( hostware_dynobj_set_write_empty_as_null )
{
    try 
    {
      //LOGI( "hostware_dynobj_set_write_empty_as_null\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_RECORD( 1, record );
        GET_PHP_PARAM_LONG  ( 2, value );

        record.set_obj_write_empty_as_null( value );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//---------------------------------------------------------------------------Ihostware_dynobj::field
/*
Field_descr* Ihostware_dynobj::field( pval* name )
{
    if( name->type == IS_LONG ) 
    {
        if( !_type ) {
            string nam = as_string(name->value.lval);
            throw_xc( "SOS-1179", c_str(nam), "NULL-Dynobj" );
        }

        return _type->field_descr_ptr( name->value.lval );
    }
    else 
    {
        convert_to_string( name );
        if( !_type )  throw_xc( "SOS-1179", name->value.str.val, "NULL-Dynobj" );
        return SOS_CAST( Record_type, _type ) -> field_descr_ptr( name->value.str.val );
    }
}
*/
//----------------------------------------------------------------------------hostware_dynobj_empty

extern "C" EXPORT PHP_FUNCTION( hostware_dynobj_empty )
{
    try 
    {
        begin();


        GET_PHP_PARAMS(1,1);
        GET_PHP_PARAM_RECORD( 1, record );

        Variant  record_vt = (IDispatch*)record;

        //RETURN_BOOL( hostware.empty( &record_vt ) );
        RETURN_BOOL( record.obj_field_count() == 0 );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//-----------------------------------------------------------------------hostware_dynobj_field_name

extern "C" EXPORT PHP_FUNCTION( hostware_dynobj_field_name )
{
    try 
    {
        Thread_semaphore::Guard guard ( &semaphore );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_RECORD( 1, record );
        GET_PHP_PARAM_LONG  ( 2, fieldnr );

        Bstr result_bstr;
        record.get_obj_field_name( fieldnr, &result_bstr );

        RETURN_BSTR( result_bstr );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//----------------------------------------------------------------------hostware_dynobj_field_index

extern "C" EXPORT PHP_FUNCTION( hostware_dynobj_field_index )
{
    try 
    {
        Thread_semaphore::Guard guard ( &semaphore );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_RECORD( 1, record );
        GET_PHP_PARAM_STRING( 2, field_name );

        RETURN_LONG( record.obj_field_index( field_name_bstr ) );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//---------------------------------------------------------------------------hostware_dynobj_field

extern "C" EXPORT PHP_FUNCTION( hostware_dynobj_field )
{
    try 
    {
        Thread_semaphore::Guard guard ( &semaphore );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_RECORD( 1, record );
        GET_PHP_PARAM_VARIANT( 2, field_name );


        Variant result;

        record.obj_field( &field_name_vt, &result );

        return_variant( result, return_value );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//-----------------------------------------------------------------------hostware_dynobj_set_field

extern "C" EXPORT PHP_FUNCTION( hostware_dynobj_set_field )
{
    try 
    {
        Thread_semaphore::Guard guard ( &semaphore );
        begin();

        GET_PHP_PARAMS(3,3);
        GET_PHP_PARAM_RECORD ( 1, record );
        GET_PHP_PARAM_VARIANT( 2, name );
        GET_PHP_PARAM_VARIANT( 3, value );

    
        record.obj_set_field( &name_vt, &value_vt );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//-----------------------------------------------------------------------hostware_dynobj_add_field

extern "C" EXPORT PHP_FUNCTION( hostware_dynobj_add_field )
{
    try 
    {
        Thread_semaphore::Guard guard ( &semaphore );
        begin();

        GET_PHP_PARAMS(3,3);
        GET_PHP_PARAM_RECORD ( 1, record );
        GET_PHP_PARAM_STRING ( 2, name   );
        GET_PHP_PARAM_STRING ( 3, type   );

        Variant type_vt = (BSTR)type_bstr;

        record.obj_add_field( name_bstr, &type_vt );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//------------------------------------------------------------------------------hostware_dynobj_xml

extern "C" EXPORT PHP_FUNCTION( hostware_dynobj_xml )
{
    try 
    {
        //LOGI( "hostware_dynobj_xml()\n" );
        begin();

        GET_PHP_PARAMS(2,2);
        GET_PHP_PARAM_RECORD ( 1, record  );
        GET_PHP_PARAM_STRING ( 2, options );

        Bstr result_bstr;

        record.get_obj_xml( options_bstr, &result_bstr );

        RETURN_BSTR( result_bstr );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//----------------------------------------------------------------------------hostware_dynobj_set_xml

extern "C" EXPORT PHP_FUNCTION( hostware_dynobj_set_xml )
{
    try 
    {
        //LOGI( "hostware_dynobj_set_xml()\n" );
        begin();

        GET_PHP_PARAMS(3,3);
        GET_PHP_PARAM_RECORD ( 1, record  );
        GET_PHP_PARAM_STRING ( 2, options );
        GET_PHP_PARAM_STRING ( 3, xml     );

        record.set_obj_xml( options_bstr, xml_bstr );
    }
    catch( const Xc& x )  { exception_to_php(x); }
}

//-------------------------------------------------------------------------------------------------

} //namespace hostphp

//-------------------------------------------------------------------------------------------------

extern "C" {

using namespace hostphp;


function_entry php_hostware_functions[] =
{
    PHP_FE( hostware_copy_file           , NULL )
    PHP_FE( hostware_remove_file         , NULL )
    PHP_FE( hostware_rename_file         , NULL )
    PHP_FE( hostware_file_as_string      , NULL )
    PHP_FE( hostware_get_single_         , NULL )
    PHP_FE( hostware_execute_direct      , NULL )
    PHP_FE( hostware_as_date             , NULL )
    PHP_FE( hostware_date_as_string      , NULL )
    PHP_FE( hostware_get_array_          , NULL )
    PHP_FE( hostware_as_xml_             , NULL )
    PHP_FE( hostware_from_xml            , NULL )
    PHP_FE( hostware_sql_quoted          , NULL )
    PHP_FE( hostware_sql_equal           , NULL )
    PHP_FE( hostware_file_exists         , NULL )
    PHP_FE( hostware_make_path           , NULL )

    PHP_FE( hostware_set_error_mode      , NULL )
    PHP_FE( hostware_error               , NULL )
    PHP_FE( hostware_exception_name      , NULL )
    PHP_FE( hostware_error_code          , NULL )
    PHP_FE( hostware_error_text          , NULL )

    PHP_FE( hostware_file__new                  , NULL )
    PHP_FE( hostware_file__delete               , NULL )
    PHP_FE( hostware_file_prepare               , NULL )
    PHP_FE( hostware_file_open                  , NULL )
    PHP_FE( hostware_file_create_record         , NULL )
    PHP_FE( hostware_file_create_key            , NULL )
    PHP_FE( hostware_file_close                 , NULL )
    PHP_FE( hostware_file_close_cursor          , NULL )
    PHP_FE( hostware_file_opened                , NULL )
    PHP_FE( hostware_file_eof                   , NULL )
    PHP_FE( hostware_file_get                   , NULL )
    PHP_FE( hostware_file_get_line              , NULL )
    PHP_FE( hostware_file_rewind                , NULL )
    PHP_FE( hostware_file_put                   , NULL )
    PHP_FE( hostware_file_put_line              , NULL )
    PHP_FE( hostware_file_set_key               , NULL )
    PHP_FE( hostware_file_delete_key            , NULL )
    PHP_FE( hostware_file_get_key               , NULL )
    PHP_FE( hostware_file_insert                , NULL )
    PHP_FE( hostware_file_store                 , NULL )
    PHP_FE( hostware_file_update                , NULL )
    PHP_FE( hostware_file_update_direct         , NULL )
    PHP_FE( hostware_file_set_parameter         , NULL )
    PHP_FE( hostware_file_set_date_format       , NULL )
    PHP_FE( hostware_file_set_date_time_format  , NULL )
    PHP_FE( hostware_file_set_decimal_symbol    , NULL )
    PHP_FE( hostware_file_field_name            , NULL )
    PHP_FE( hostware_file_field_count           , NULL )

    PHP_FE( hostware_dynobj__delete             , NULL )
    PHP_FE( hostware_dynobj_clone               , NULL )
    PHP_FE( hostware_dynobj_set_write_empty_as_null, NULL )
    PHP_FE( hostware_dynobj_empty               , NULL )
    PHP_FE( hostware_dynobj_field_name          , NULL )
    PHP_FE( hostware_dynobj_field_index         , NULL )
    PHP_FE( hostware_dynobj_field               , NULL )
    PHP_FE( hostware_dynobj_set_field           , NULL )
    PHP_FE( hostware_dynobj_add_field           , NULL )
    PHP_FE( hostware_dynobj_xml                 , NULL )
    PHP_FE( hostware_dynobj_set_xml             , NULL )
/*
    PHP_FE( hostware_variable__new              , NULL )
    PHP_FE( hostware_variable__delete           , NULL )
    PHP_FE( hostware_variable_set_value         , NULL )
    PHP_FE( hostware_variable_value             , NULL )
    PHP_FE( hostware_variable_dim               , NULL )
    PHP_FE( hostware_variable_name              , NULL )
*/
    { NULL, NULL, NULL }
};


zend_module_entry php_hostware_module_entry = 
{
	STANDARD_MODULE_HEADER,         // PHP 4.2.1
    "hostware",
    php_hostware_functions,
    PHP_MINIT(hostware),
    PHP_MSHUTDOWN(hostware),
    NULL,
    NULL,
    PHP_MINFO(hostware),
    STANDARD_MODULE_PROPERTIES
};


ZEND_GET_MODULE(php_hostware)

//--------------------------------------------------------------------PHP_MINIT_FUNCTION(hostware)

PHP_MINIT_FUNCTION(hostware)
{
    using namespace hostphp;

    try 
    {
        Thread_semaphore::Guard guard ( &semaphore );

        //appl.init();

        add_error_code_texts( error_texts );

        if( !hostware )
        {
            hostware.CoCreateInstance( L"Hostware.Global" );

#           ifdef _WIN32
                hostware_thread_id = GetCurrentThreadId();
#           endif
        }

        if( !log_file )
        {
            HRESULT hr = log_file.CoCreateInstance( L"Hostware.File" );
            if( FAILED(hr) )  throw_com( hr, "CoCreateInstance" );

            //string log_file = read_profile_string( "", "hostphp", "log" );
            //if( !empty( log_file ) )  log_start( log_file );

            log_file.open( "-out -binary log :" );
        }


        log_file.put_line( "PHP_MINIT_FUNCTION\n" );

        Bstr product_name = L"hostphp";
        hostware.check_licence( product_name );
        //if( !SOS_LICENCE( licence_hostphp ) )  throw_xc( "SOS-1000", "hostPHP" );

        error_mode = E_WARNING;
    }
    catch( const Xc& x )  
    {     
        php_error( E_ERROR, "%s", (char*)x.what() );
        return E_ERROR;
    }

    return SUCCESS;
}

//----------------------------------------------------------------PHP_MSHUTDOWN_FUNCTION(hostware)

PHP_MSHUTDOWN_FUNCTION(hostware)
{
    using namespace hostphp;

    Thread_semaphore::Guard guard ( &semaphore );

    LOG( "PHP_MSHUTDOWN\n" );

    int i;

    for( i = record_array.size() - 1; i >= 0; i-- )
    {
        if( record_array[i] )
        {
            LOG( "hostPHP: Dynobj " << i << " wird freigegeben.\n" );
            record_array[i] = NULL;
        }
    }

    for( i = file_array.size() - 1; i >= 0; i-- )  
    {
        if( file_array[i] )
        {
            LOG( "hostPHP: File " << i << " wird freigegeben.\n" );
            file_array[i] = NULL;
        }
    }

    delete last_xc;  last_xc = NULL;

    log_file = NULL;
    hostware = NULL;

    //appl.exit();

    return SUCCESS;
}

//--------------------------------------------------------------------PHP_MINFO_FUNCTION(hostware) 

PHP_MINFO_FUNCTION(hostware)
{
    php_info_print_table_start();
    php_info_print_table_row(2, "hostWare Support", "enabled");
    php_info_print_table_row(2, "Compiled Version", VER_PRODUCTVERSION_STR );
    php_info_print_table_row(2, "Linked Version"  , VER_PRODUCTVERSION_STR );
    php_info_print_table_end();
}

} //extern "C"

//-----------------------------------------------------------------------------------------DllMain

#ifdef _WIN32

extern "C"      
BOOL WINAPI DllMain( HANDLE hInst, DWORD ul_reason_being_called, LPVOID )
{
    using namespace hostphp;

    switch( ul_reason_being_called )
	{
		case DLL_PROCESS_ATTACH: 
        {
            _CrtSetDbgFlag( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF );   // Speicherprfung bei _DEBUG
            zschimmer_init();
            break;
        }

    	case DLL_PROCESS_DETACH: 
        {
          //appl.exit();
            //if( hostware_thread_id == GetCurrentThreadId() )  hostware = NULL;
            hostware.p = NULL;   // hostole.dll ist schon fort, also Objekt nicht mehr anrhren
            log_file.p = NULL;

            if( last_xc )  delete last_xc;
            zschimmer_terminate();
            _CrtDumpMemoryLeaks();
            break;
        }

		case DLL_THREAD_ATTACH: 
            break;

    	case DLL_THREAD_DETACH: 
            if( hostware_thread_id == GetCurrentThreadId() )  hostware = NULL,  log_file = NULL;   // Bei Thread-Ende sofort freigeben, wegen Apartment Model von hostole
            break;

		default: break;
	} 

    return TRUE;
}

#endif
