

/*
    misc.profile = { get }
    misc.profile.*    = { get, include }
    misc.profile.get
    misc.profile.include
    misc.com

    log.programname
    log.virtual_size

    scheduler.wait
    scheduler.sockets

    java.calls
    java.stacktrace
    java.options

    objectserver.call

    
    logxx = misc.profile !log.programmname java.calls

    -------------------

    log_categories.add( "misc.profile !log.programmname java.calls" );
    
    log_categories.set_default( "misc.profile.get" );


    if( log_categories( "misc.profile.include" ) ) ...;

*/



struct Log_categories : Object
{
    add( const string& category );
    set_defaults( const string& category );
    bool is_set( const string& name );

    typedef stdext::hash_map< string, ptr<Log_categories >  Map;
    Map _map;
};



bool Log_categories::is_set( const string& name )
{
    if( name == "*" )  return true;

    int p = name.find( '.' );  
    boolean has_point = p == string::npos;

    Map::iterator it = _map.find( has_point? name.substr( 0, p ) : name );
    if( it == Map::end )  return false;

    if( has_point  &&  it->second )
    {
        return it->second->is_set( name.substr( p+1 ) );
    }
    else
        return true;
}


void Log_categories::set( const string& name )
{
    int p = name.find( '.' );  
    boolean has_point = p == string::npos;

    ptr<Log_categories>& p = _map[ has_point? name.substr( 0, p ) : name ];

    if( has_point )
    {
        if( p )  p->set( name.substr( p+1 ) );
           else  p = new Log_categories( name );
    }
    if( has_point  &&  it->second )
    {
        return it->second->is_set( name.substr( p+1 ) );
    }
    else
        return true;
}


bool Log_categories::is_set( const vector<string>& name_vector, int idx )
{
    if( name == "*" )  return true;

    int p = name.find( '.' );  
    boolean has_point = p == string::npos;

    Map::iterator it = _map.find( has_point? name.substr( 0, p ) : name );
    if( it == Map::end )  return false;

    if( has_point  &&  it->second )
    {
        return it->second->is_set( name.substr( p+1 ) );
    }
    else
        return true;
}



void Log_categories::get_names( vector<string>* result, string path )
{
    int p = name.find( '.' );  
    boolean has_point = p == string::npos;

    Map::iterator it = _map.find( has_point? name.substr( 0, p ) : name );
    if( it == Map::end )  return false;

    if( has_point  &&  it->second )
    {
        return it->second->is_set( name.substr( p+1 ) );
    }
    else
        return true;
}


